package Elements;

import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import Elements.Desiccant.Salt;

public class tests {
	
	public static void plotEffectiveness(){
		Desiccant d = new Desiccant();
		Air a = new Air();
		try{
		d.setType(Salt.LiCl);
		double m_a = 5.0;
		Node DSI = new Node(a, 35.0, 0.021 / 1.021, 7.55 / 3600.0);
		Node SSI = new Node(d, 25.0, 0.35, 9.89 / 3600.0);
		LAMEE l = new LAMEE();
		l.setDI(DSI);
		l.setSI(SSI);
		l.setUA(9.27);
		l.setUA_m(3.31E-3);
		while(m_a <= 20.0){
			DSI.setMFlow(m_a / 3600.0);
			l.setDI(DSI);
			System.out.println(String.format(Locale.US, "%.1f", m_a) + "\t" 
			+ String.valueOf(l.getEffS()) + "\t" + String.valueOf(l.getEffL()));
			m_a += 0.1;
		}
		} catch (OutOfRangeException ex){
			System.out.println(ex.getMessage());
		}
	}
	
	public static void plotEffectiveness2(){
		Desiccant d = new Desiccant();
		Air a = new Air();
		try{
		d.setType(Salt.LiCl);
		Node DSI = new Node(a, 35.0, 0.021 / 1.021, 10.52 / 3600.0);
		Node SSI = new Node(d, 25.0, 0.35, 9.89 / 3600.0);
		LAMEE2 l = new LAMEE2();
		l.setDI(DSI);
		l.setSI(SSI);
		l.setMsen(0.411768626);
		l.setLe_tot(2.985295276);
		l.setNTUsen(3.397063902);
		l.setMabs(1.647038152);
		System.out.println("Eff_S = " + l.getEffS());
		System.out.println("Eff_L = " + l.getEffL());
		} catch(OutOfRangeException ex){
			System.out.println(ex.getMessage());
		}
	}
	
	public static void ThermalLoss(){
		double h_oo = 7.0; // W/m^2-K
		double h_f = 135.0; // W/m^2-K
		double k_p = 0.24; // W/m-K
		double k_w = 0.036; // W/m-K
		double r_i = 13.2E-3 / 2.0; // m
		double r_w = 20.0E-3 / 2.0; // m
		double r_o = r_w + 12.7; // m
		double L = 10.0; // m
		double T_dlo = 15.0; // C
		Desiccant des = new Desiccant();
		try{
		des.setTem(T_dlo);
		double m_dl = des.getDensity() * 34E-3 / 60.0; // kg / s
		double c_p = des.getSpHeat(); // kJ/kg-K
		double T_oo = 40.0; // C
		double U = 1.0 / (1 / h_f + r_i / k_p * Math.log(r_w / r_i)
					+ r_i / k_w * Math.log(r_o / r_w) + r_i / r_o / h_oo);
		double A_i = 2 * Math.PI * r_i * L;
		double T_dl = T_oo + (T_dlo - T_oo) * Math.exp(- U * A_i / m_dl / c_p / 1000.0);
		System.out.println(String.format("%.2f", T_dl) + " C");
		double Q = U * A_i * (T_oo - T_dlo);
		T_dl = T_dlo + Q / m_dl / c_p / 1000.0;
		System.out.print(String.format("%.2f", T_dl) + " C");
		} catch(OutOfRangeException ex){
			System.out.println(ex.getMessage());
		}
	}
	
	public static void plotWDensity(){
		Water water = new Water();
		for(double T = -40.0; T < 100.0; T = T + 0.1){
			try{
			water.setTem(T);
			System.out.println(String.format(Locale.US, "%.2f", T) + "\t" 
					+ String.valueOf(water.getDensity()));
			} catch(OutOfRangeException ex){
				/// It doesn't print the line
			}
		}
	}
	
	public static void plotWPs(){
		Water water = new Water();
		for(double Ps = 0.0; Ps < 100.0; Ps = Ps + 0.1){
			try{
			water.setTem(Ps);
			System.out.println(String.format(Locale.US, "%.2f", Ps) + "\t" 
					+ String.valueOf(water.getPs()));
			} catch(OutOfRangeException ex){
				System.out.println(ex.getMessage());
			}
		}

	}
	
	public static void plotWConductivity(){
		Water water = new Water();
		for(double T = -20.0; T < 100.0; T = T + 0.1){
			try{
			water.setTem(T);
			System.out.println(String.format(Locale.US, "%.2f", T) + "\t" 
					+ String.valueOf(water.getThConductivity()));
			} catch(OutOfRangeException ex){
				System.out.println(ex.getMessage());
			}
		}
	}
	
	public static void plotWSpHeat(){
		Water water = new Water();
		for(double t = -40.0; t < 100.0; t = t + 0.1){
			try{
			water.setTem(t);
			System.out.println(String.format(Locale.US, "%.2f", t) + "\t" 
					+ String.valueOf(water.getSpHeat()));
			} catch(OutOfRangeException ex){
				System.out.println(ex.getMessage());
			}
		}
	}
	
	public static void plotWViscosity(){
		Water water = new Water();
		for(double u = 0.0; u < 100.0; u = u + 0.1){
			try{
				water.setTem(u);
				System.out.println(String.format(Locale.US, "%.2f", u) + "\t" 
					+ String.valueOf(water.getViscosity()));
			} catch(OutOfRangeException ex){
				System.out.println(ex.getMessage());
			}
		}
	}
	
	public static void plotDDensity(){
		Desiccant d = new Desiccant();
		Water w = new Water();
		String epsilon, density;
		try{
		d.setType(Salt.CaCl2);
		d.setTem(20.0);
		w.setTem(20.0);
		} catch(OutOfRangeException ex){
			System.out.println("The properties specified are out of range");
			System.out.println("At plotDDensity()");
		}
		for (double i = 0.0; i <= 0.6; i += 0.001){
			try{
			d.setXCon(i);
			epsilon = String.valueOf(i / (1.0 - i));
			density = String.valueOf(d.getDensity() / w.getDensity());
			System.out.println(epsilon + "\t" + density);
			} catch(OutOfRangeException ex){
				//This line is not plotted
			}
		}
	}
	
	public static void plotThConductivity(){
		try{
			PrintWriter pw = new PrintWriter(new FileWriter("data.dat"));
			Desiccant d = new Desiccant();
			d.setType(Salt.LiCl);
			String line;
			for (double i = 0.0; i <= 0.6; i += 0.001){
				d.setXCon(i);
				line = String.valueOf(i);
				for(double j = -20.0; j <= 100; j += 10.0){
					d.setTem(j);
					line += "\t" + String.valueOf(d.getThConductivity());
				}
				pw.println(line);
			}
			pw.close();
		} catch (IOException ex){
			System.out.println(ex.getMessage());
		} catch (OutOfRangeException ex){
			System.out.println(ex.getMessage());
		}
	}
	
	public static void plotSpEnthalpy(){
		PrintWriter pw;
		Desiccant d = new Desiccant();
		try{
			d.setType(Salt.LiCl);
		} catch (OutOfRangeException ex){
			System.out.println(ex.getMessage());
		}
		String line;
		for (double i = 10.0; i <= 100.0; i += 10.0){
			try{
				pw = new PrintWriter(new FileWriter("data" + String.format("%.0f", i) + ".dat"));
				for(double j = 0.0; j <= 0.6; j += 0.01){
					try{
						d.setTem(i);
						d.setXCon(j);
						line = String.valueOf(j);
						line += "\t" + String.valueOf(d.getSpEnthalpy());
						pw.println(line);
					} catch (OutOfRangeException ex){
						
					}
				}
				pw.close();
			} catch (IOException ex){
				System.out.println(ex.getMessage());
			}
		}
	}
	
	public static void plotViscosity(){
		PrintWriter pw;
		String line;
		Desiccant d = new Desiccant();
		double[] T = {-20.0, -10.0, 0.0, 10.0, 25.0, 50.0, 80.0, 90.0, 100.0};
		try{
			d.setType(Salt.CaCl2);
		} catch(OutOfRangeException ex){
			System.out.println("The initial value is out of range.");
			System.out.println("At plotViscosity()");
		}
		for (int j = 0; j < T.length; j++){
			try{
				pw = new PrintWriter(new FileWriter("data" + String.format("%.1f", T[j]) + ".dat"));
				for (double i = 0.0; i <= 0.524; i += 0.001){
					try{
						d.setXCon(i);
						d.setTem(T[j]);
						line = String.valueOf(i);
						line += "\t" + String.valueOf(d.getViscosity() / 1000.0);
						pw.println(line);
					} catch (OutOfRangeException ex){
						// It doesn't print that line
					}
				}
				pw.close();
			} catch (IOException ex){
				System.out.println(ex.getMessage());
			}
		}
	}
	
	public static double getWViscosity(double T){
		Water w = new Water();
		try{
		w.setTem(T);
		double ph = w.getDensity() / 317.763;
		double[][] G = {{0.5132047, 0.2151778, -0.2818107, 0.1778064, -0.0417661, 0.0, 0.0},
				{0.3205656, 0.7317883, -1.070786, 0.460504, 0.0, -0.01578386, 0.0},
				{0.0, 1.241044, -1.263184, 0.2340379, 0.0, 0.0, 0.0},
				{0.0, 1.476783, 0.0, -0.4924179, 0.1600435, 0.0, -0.003629481},
				{-0.7782567, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
				{0.1885447, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
				double[] mu = new double[2];
				double th = (T + 273.15) / 647.226;
				mu[0] = Math.sqrt(th) / (1.0 + 0.978197 / th + 0.579829 / th / th - 0.202354 / th / th / th);
				mu[1] = 0.0;
				double value;
				for(int i = 0; i <= 5; i++){
					value = 0.0;
					for(int j = 0; j <=6; j++){
						value += G[i][j] * Math.pow(1.0 / th - 1.0, (double) i) * Math.pow(ph, (double) j);
					}
					mu[1] += value;
				}
				mu[1] *= ph;
				return mu[0] * Math.exp(mu[1]) * 55.071;
		} catch (OutOfRangeException ex){
			System.out.println(ex.getMessage());
			return 0.0;
		}
	}
	
	public static double getWDensity(double tem){
		double tau = 1 - (273.15 + tem) / 647.226;
		return 332*(1 + 1.993771843 * Math.pow(tau, 1.0 / 3.0) 
		+ 1.0985211604 * Math.pow(tau, 2.0 / 3.0)
		- 0.5094492996 * Math.pow(tau, 5.0 / 3.0)
		- 1.7619124270 * Math.pow(tau, 16.0 / 3.0)
		- 44.9005480267 * Math.pow(tau, 43.0 / 3.0)
		- 723692.2618632 * Math.pow(tau, 110.0 / 3.0));
	}
	
	public static void plotDPs(){
		PrintWriter pw;
		Desiccant D = new Desiccant();
		Water W = new Water();
		String line;
		double[] T = {25.0, 50.0, 80.0, 100.0};
		try{
		D.setType(Salt.LiCl);
		} catch(OutOfRangeException ex){
			System.out.println("The initial values are out of range");
			System.out.println("At plotDPs()");
		}
		for (int j = 0; j < T.length; j++){
			try{
				pw = new PrintWriter(new FileWriter("data" + String.format("%.1f", T[j]) + ".dat"));
				for (double i = 0.0; i < 0.7; i += 0.01){
					try{
						D.setXCon(i);
						D.setTem(T[j]);
						W.setTem(T[j]);
						line = String.valueOf(i) + "\t" 
							+ String.valueOf(D.getPs() / W.getPs());
						pw.println(line);
					} catch(OutOfRangeException ex){
						// it doesn't print that line
					}
				}
				pw.close();
			} catch (IOException ex){
			System.out.println(ex.getMessage());
			}
		}

	}
	
	public static void plotSpHeat(){
		try{
			PrintWriter pw;
			Desiccant d = new Desiccant();
			String line;
			try {
			d.setType(Salt.LiCl);
			} catch (OutOfRangeException ex){
				System.out.println("Initial state is out of range");
				System.out.println("At plotSpHeat()");
			}
			for(double j = 0.0; j <=0.5; j += 0.05){
				line = String.format("%.2f", j);
				line.replace(',', '_');
				pw = new PrintWriter(new FileWriter("data" + line + ".dat"));
				for(double i = -20.0; i <= 100.0; i += 0.01){
					try{
						d.setTem(i);
						d.setXCon(j);
						line = String.valueOf(i);
						line += "\t" + String.valueOf(d.getSpHeat());
						pw.println(line);
					} catch(OutOfRangeException ex) {
						// It does not print the line
					}
				}
				pw.close();
			}
		} catch(IOException ex){
			System.out.println(ex.getMessage());
		} 
	}
	
	public static void LAMEETest1(){
		LAMEE l = new LAMEE();
		Node DI = new Node(new Air(), 20.0, 0.01, 5 / 3600.0);
		Node SI = new Node(new Desiccant(), 15.0, 0.01, 10 / 3600.0);
		l.setEffL(1.0);
		l.setEffS(0.0);
		try{
		l.setDI(DI);
		l.setSI(SI);
		System.out.println("CARACTERSTICAS DEL LAMEE:");
		System.out.println("Eficiencia sensible: " + l.getEffS());
		System.out.println("Eficiencia latente: " + l.getEffL());
		System.out.println("CONDICIONES DE ENTRADA:");
		System.out.println("Temperatura de entrada del aire: " + l.DSI.getTem() + "C");
		System.out.println("Razn de humedad de entrada del aire: " + l.DSI.getHum() + "C");
		System.out.println("Flujo msico de entrada del aire: " + l.DSI.getMFlow() * 3600.0 + " kg/h");
		System.out.println("Temperatura de entrada del desecante: " + l.SSI.getTem() + "C");
		System.out.println("Razn de humedad de entrada del desecante: " + l.SSI.getHum() + " kg/kg");
		System.out.println("Flujo msico de entrada del desecante: " + l.SSI.getMFlow() * 3600.0 + " kg/h");
		System.out.println("CONDIDIONES DE SALIDA:");
		System.out.println("Temperatura de salida del aire: " + l.DSO.getTem() + "C");
		System.out.println("Razn de humedad de salida del aire: " + l.DSO.getHum() + " kg/kg");
		System.out.println("Flujo msico de salida del aire: " + l.DSO.getMFlow() * 3600.0 + " kg/h");
		System.out.println("Temperatura de salida del desecante: " + l.SSO.getTem() + "C");
		System.out.println("Razn de humedad de salida del desecante: " + l.SSO.getHum() + " kg/kg");
		System.out.println("Flujo msico de salida del desecante: " + l.SSO.getMFlow() * 3600.0 + " kg/h");
		} catch (OutOfRangeException ex){
			
		}
	}
	public void displayPPC(){
		PumpPerformedCurve PPC = new PumpPerformedCurve();
		PPC.setN(1750.0 / 60.0);
		PPC.setD(7 * 0.0254);
		PPC.setQBEP(0.008);
		PPC.setQmax(0.011);
		double[] C = {5.9011E-3, -3.136E-3, 0.1819, -18.8921, 188.5304};
		PPC.setC(C);
		for(double q = 0.0; q <= 0.011; q += 0.0001){
			System.out.println(q + "\t" + PPC.getH(q,  1000));
		}
	}
	
	public static void adjustPump(){
		Pump p = new Pump();
		p.setNI(new Node(new Water(), 20.0, 0.0, 5.0));
		PumpPerformedCurve PPC = new PumpPerformedCurve();
		PPC.setN(1750.0 / 60.0);
		PPC.setD(7 * 0.0254);
		PPC.setQBEP(0.008);
		PPC.setQmax(0.011);
		double[] C = {5.9011E-3, -3.136E-3, 0.1819, -18.8921, 188.5304};
		PPC.setC(C);
		p.setH(140.0);
		p.setPPC(PPC);
		System.out.println("The input data is:");
		System.out.println(p.getNI().getMFlow() + " kg/s");
		System.out.println(p.getNI().getPressure() + " kPa");
		System.out.println("The ouput data is:");
		System.out.println(p.getNO().getMFlow() + " kg/s");
		System.out.println(p.getNO().getPressure() + " kPa");
	}
	
	public static void PPC_QH(){
		PumpPerformedCurve PPC = new PumpPerformedCurve();
		PPC.setN(1750.0 / 60.0);
		PPC.setD(7 * 0.0254);
		PPC.setQBEP(0.008);
		PPC.setQmax(0.011);
		double[] C = {5.9011E-3, -3.136E-3, 0.1819, -18.8921, 188.5304};
		PPC.setC(C);
		try{
		System.out.println("La presin de trabajo es de 150 kPa, "
				+ "para un caudal de " + PPC.getQ(150.0, 1000.0) + " m^3/s");
		System.out.println("El caudal de trabajo es de 0.005 m^3/s, "
				+ "para una presin de " + PPC.getH(0.005, 1000.0) + " kPa");
		} catch (OutOfRangeException ex){
			System.out.println("El valor no est en el rango de trabajo de la curva.");
		}
	}
	
	public static void testPPC(){
		PumpPerformedCurve PPC = new PumpPerformedCurve();
		Desiccant d = new Desiccant();
		try{
		d.setTem(20.0);
		d.setXCon(0.3);
		} catch(OutOfRangeException ex){
			
		}
		PPC.setN(1750.0 / 60.0);
		PPC.setD(7 * 0.0254);
		PPC.setQBEP(0.008);
		PPC.setQmax(0.011);
		double[] C = {5.9011E-3, -3.136E-3, 0.1819, -18.8921, 188.5304};
		PPC.setC(C);
		double[] Cx = PPC.getViscFactors(d.getViscosity(), d.getDensity());
		System.out.println("C_e = " + Cx[0]);
		System.out.println("C_q = " + Cx[1]);
		System.out.println("C_h = " + Cx[2]);
	}
	
	
	public static void pruebaLAMEE2(){
		Desiccant d = new Desiccant();
		Air a = new Air();
		try{
		d.setType(Salt.LiCl);
		Node DSI = new Node(a, 35.0, 0.021 / 1.021, 7.55 / 3600.0);
		Node SSI = new Node(d, 25.0, 0.35, 9.89 / 3600.0);
		LAMEE l = new LAMEE();
		l.setDI(DSI);
		l.setSI(SSI);
		l.setUA(9.27);
		l.setUA_m(3.31E-3);
		System.out.println("Eff_S = " + l.getEffS());
		System.out.println("Eff_L = " + l.getEffL());
		System.out.println("T_a,in = " + l.DSI.getTem());
		System.out.println("W_a,in = " + l.DSI.getHum());
		System.out.println("T_a,out = " + l.DSO.getTem());
		System.out.println("W_a,out = " + l.DSO.getHum());
		System.out.println("T_dl,in = " + l.SSI.getTem());
		System.out.println("X_dl,in = " + l.SSI.getXCon());
		System.out.println("T_dl,out = " + l.SSO.getTem());
		System.out.println("X_dl,out = "+ l.SSO.getXCon());
		} catch (OutOfRangeException ex){
			System.out.println(ex.getMessage());
		}
	}
	
	public static void psicro(){
		Air air = new Air();
		try{
		PrintWriter pw = new PrintWriter("Report.tsv");
			for(double t = 0.0; t <= 50.0; t += 0.1){
				air.setRH(0.0);
				air.setTem(t);
				for(double rh = 0.0; rh <= 1.0; rh += 0.01){
					air.setRH(rh);
					pw.print(String.format(Locale.US, "%.1f", air.getTem()) + "\t");
					pw.print(String.format(Locale.US, "%.1f", air.getHum() * 1000.0) + "\t");
					pw.print(String.format(Locale.US, "%.3f", air.getRH()) + "\t");
					pw.print(String.format(Locale.US, "%.4f", 1.0 / air.getDensity()) + "\t");
					pw.println(String.format(Locale.US, "%.3f", air.getSpEnthalpy()));
				}
				pw.println();
			}	
			pw.close();
		} catch (OutOfRangeException ex){
			System.out.println(ex.getMessage());
		} catch (FileNotFoundException ex){
			System.out.println(ex.getMessage());
		}   
	}
	
	public static void testPloss(){
		Pipe p = new Pipe();
		Water w = new Water();
		Node n = new Node();
		n.setFluid(w);
		n.setTem(10.0);
		n.setMFlow(n.getDensity() * 3.0 * 0.0631E-3);
		try{
			p.setNI(n);
		} catch(OutOfRangeException ex){
			System.out.println(ex.getMessage());
		}
		p.setOD(0.84 * 0.0254);
		p.setPpThick(0.109 * 0.0254);
		p.setLength(1.0);
		p.setPpLFactor(0.03404);
		System.out.println("Head Loss: " + p.getPloss() * 1000.0 / 98.1 + " ft / 100 ft");
	}
	
	public static void main(String[] args){
		Pipe p = new Pipe();
		Air a = new Air();
		Node n = new Node();
		n.setFluid(a);
		n.setTem(6);
		try{
			p.setNI(n);
		} catch(OutOfRangeException ex){
			System.out.println(ex.getMessage());
		}
		p.setTamb(23.0);
		p.setOD(0.040);
		p.setPpThick(0.002);
		p.setPpThCond(16.2);
		p.setInThick(0.0);
		p.setInThCond(0.05);
		p.setLength(1.0);
		p.setHoo(6);
		p.setHf(400.0);
		System.out.println("Heat loss case A: " + p.getQloss() + " W / m");
		p.setInThick(0.01);
		System.out.println("Heat Loss case B: " + p.getQloss() + " W / m");
	}
}
