package SIM;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Locale;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.JToggleButton;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class GHX extends JDialog implements ActionListener{
	private JLabel lbEffS;
	private JLabel lbEffL;
	private JLabel lbSPL;
	private JLabel lbDPL;
	private JRadioButton tbLAMEE;
	private JTextField txtEffS;
	private JTextField txtEffL;
	private JTextField txtSPL;
	private JTextField txtDPL;
	private JButton btAccept;
	private JButton btCancel;
	private boolean dialogResult;
	private ItemListener Auto;
	
	enum Modality{
		HX,
		LAMEE
	}
	
	public GHX(JFrame parent){
		InitializeEvents();
		InitializeComponents(parent);
	}
	
	public void InitializeEvents(){
		Auto = new ItemListener(){
			@Override
			public void itemStateChanged(ItemEvent ev) {
				if(tbLAMEE.isSelected()){
					lbEffS.setText("UA (W/K)");
					lbEffL.setText("UA_m (L/s)");
					txtEffS.setText("10.0");
					txtEffL.setText("3.0");
				} else {
					lbEffS.setText("Sensible");
					lbEffL.setText("Latente");
					txtEffS.setText("0.8");
					txtEffL.setText("0.8");
				}
			}
		};
	}
	
	public void InitializeComponents(JFrame myParent){
		lbEffS = new JLabel();
		lbEffL = new JLabel();
		lbSPL = new JLabel();
		lbDPL = new JLabel();
		txtEffS = new JTextField();
		txtEffL = new JTextField();
		txtSPL = new JTextField();
		txtDPL = new JTextField();
		tbLAMEE = new JRadioButton();
		btAccept = new JButton();
		btCancel = new JButton();
		Dimension lbDim = new Dimension(140, 18);
		Dimension txtDim = new Dimension(50, 20);
		/*
		 * lbEffS
		 */
		lbEffS.setName("lbEffS");
		lbEffS.setText("Eficacia sensible");
		lbEffS.setSize(lbDim);
		lbEffS.setLocation(10, 10);
		
		/*
		 * lbEffL
		 */
		lbEffL.setName("lbEffL");
		lbEffL.setText("Eficacia latente");
		lbEffL.setSize(lbDim);
		lbEffL.setLocation(10, 40);
		
		/*
		 * lbSPL
		 */
		lbSPL.setName("lbSPL");
		lbSPL.setText("Supply Loss (Pa)");
		lbSPL.setSize(lbDim);
		lbSPL.setLocation(10, 70);
		
		/*
		 * lbDPL
		 */
		lbDPL.setName("lbDPL");
		lbDPL.setText("Demand Loss (Pa)");
		lbDPL.setSize(lbDim);
		lbDPL.setLocation(10, 100);
		
		/*
		 * txtEffS
		 */
		txtEffS.setName("txtEffS");
		txtEffS.setSize(txtDim);
		txtEffS.setLocation(150, 10);
		
		/*
		 * txtEffL
		 */
		txtEffL.setName("txtEffL");
		txtEffL.setSize(txtDim);
		txtEffL.setLocation(150, 40);
		
		/*
		 * txtSPL
		 */
		txtSPL.setName("txtSPL");
		txtSPL.setSize(txtDim);
		txtSPL.setLocation(150, 70);
		
		/*
		 * txtDPL
		 */
		txtDPL.setName("txtDPL");
		txtDPL.setSize(txtDim);
		txtDPL.setLocation(150, 100);
		
		/*
		 * tbLAMEE
		 */
		tbLAMEE.setName("tbLAMEE");
		tbLAMEE.setText("Auto");
		tbLAMEE.setSize(80, 20);
		tbLAMEE.setLocation(10, 130);
		tbLAMEE.addItemListener(Auto);
		
		/*
		 * btAccept
		 */
		btAccept.setName("btAccept");
		btAccept.setText("Aceptar");
		btAccept.setSize(100, 20);
		btAccept.setLocation(100, 130);
		btAccept.addActionListener(this);
		/*
		 * btCancel
		 */
		btCancel.setName("btCancel");
		btCancel.setText("Cancelar");
		btCancel.setSize(100, 20);
		btCancel.setLocation(100, 160);
		btCancel.addActionListener(this);
		/*
		 * Geff
		 */
		this.setTitle("Eficacias");
		this.setModalityType(ModalityType.APPLICATION_MODAL);
		this.setSize(new Dimension(220, 230));
		this.setLocationRelativeTo(myParent);
		this.setResizable(false);
		this.setLayout(null);
		this.add(lbEffS);
		this.add(lbEffL);
		this.add(lbSPL);
		this.add(lbDPL);
		this.add(txtEffS);
		this.add(txtEffL);
		this.add(txtSPL);
		this.add(txtDPL);
		this.add(tbLAMEE);
		this.add(btAccept);
		this.add(btCancel);
	}
	
	public static double[] getData(JFrame parent, String title, double[] data, Modality mode){
		GHX form = new GHX(parent);
		form.setTitle(title);
		if (data[0] > 0.9) {
			form.tbLAMEE.setSelected(true);
		}
		form.txtEffS.setText(String.format(Locale.US, "%.2f", data[1]));
		form.txtSPL.setText(String.format(Locale.US, "%.0f", data[2] * 1000.0));
		form.txtDPL.setText(String.format(Locale.US, "%.0f", data[3] * 1000.0));
		form.txtEffL.setText(String.format(Locale.US, "%.2f", data[4]));
		if (mode == Modality.HX){
			form.lbEffL.setVisible(false);
			form.txtEffL.setVisible(false);
		}
		form.setVisible(true);
		if(form.getDialogResult() == true){
			data[1] = Double.parseDouble(form.txtEffS.getText());
			data[2] = Double.parseDouble(form.txtSPL.getText()) / 1000.0;
			data[3] = Double.parseDouble(form.txtDPL.getText()) / 1000.0;
			data[4] = Double.parseDouble(form.txtEffL.getText());
			data[0] = (form.tbLAMEE.isSelected()) ? 1.0 : 0.0;
		}
		return  data;
	}
	
	public boolean getDialogResult(){
		return dialogResult;
	}
	@Override
	public void actionPerformed(ActionEvent e){
		if (e.getSource() == btAccept){
			dialogResult = true;
			this.setVisible(false);
		} else { //btCancel
			dialogResult = false;
			this.setVisible(false);
		}
	}
}
