package SIM;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.Locale;
import java.awt.event.ActionEvent;

import Elements.Air;
import Elements.Desiccant;
import Elements.Node;
import Elements.Water;

public class GNode extends JDialog implements ActionListener, KeyListener {
	/**
	 * 
	 */
	private static final long serialVersionUID = -1961527431655229074L;
	// Components
	private JLabel lbFluid;
	private JLabel lbPressure;
	private JLabel lbTem;
	private JLabel lbXCon;
	private JLabel lbMF;
	private JComboBox<String> cbFluid;
	private JTextField tfPressure;
	private JTextField tfTem;
	private JTextField tfXCon;
	private JTextField tfMF;
	private JButton btAccept;
	private JButton btCancel;
	private boolean FluidBlocked;
	private boolean dialogResult;
	
	//Events
	private KeyAdapter DialogKey;
	
	public enum Modality{
		ALL_MODIFIABLE,
		KEEP_FLUID,
		KEEP_PRESSURE,
		KEEP_XCON,
		ONLY_READING
	}
	
	public GNode(JFrame parent){
		FluidBlocked = false;
		InitializeComponents("Aire", parent);
	}
	
	public GNode(JFrame parent, Node node){
		FluidBlocked = true;
		String SFluid = node.getFluid().getName();
		if (SFluid == "Air"){
			SFluid = "Aire";
		} else if (SFluid == "Water"){
			SFluid = "Agua";
		} else {
			SFluid = "Desecante";
		}
		InitializeComponents(SFluid, parent);
	}
	
	private void InitializeComponents(String iSelected, JFrame myParent){
		lbFluid = new JLabel();
		lbPressure = new JLabel();
		lbTem = new JLabel();
		lbXCon = new JLabel();
		lbMF = new JLabel();
		String[] Fluids = {"Aire", "Agua", "Desecante"};
		cbFluid = new JComboBox<>(Fluids);
		tfPressure = new JTextField();
		tfTem = new JTextField();
		tfXCon = new JTextField();
		tfMF = new JTextField();
		btAccept = new JButton();
		btCancel = new JButton();
		/*
		 * lbFluid
		 */
		lbFluid.setName("lbFluid");
		lbFluid.setSize(150, 18);
		lbFluid.setLocation(20, 21);
		lbFluid.setText("Fluido:");
		/*
		 * lbPressure
		 */
		lbPressure.setName("lbPressure");
		lbPressure.setSize(150, 18);
		lbPressure.setLocation(20, 46);
		lbPressure.setText("Presin (kPa):");
		/*
		 * lbTem
		 */
		lbTem.setName("lbTem");
		lbTem.setSize(150, 18);
		lbTem.setLocation(20, 71);
		lbTem.setText("Temperatura (C):");
		/*
		 * lbXCon
		 */
		lbXCon.setName("lbXCon");
		lbXCon.setSize(150, 18);
		lbXCon.setLocation(20, 96);
		lbXCon.setText("Concentracin (g/kg):");
		/*
		 * lbMF
		 */
		lbMF.setName("lbMF");
		lbMF.setSize(150, 18);
		lbMF.setLocation(20, 121);
		lbMF.setText("Flujo Msico (kg/h):");
		/*
		 * cbFluid
		 */
		cbFluid.setName("cbFluid");
		cbFluid.setSize(90, 20);
		cbFluid.setLocation(175, 20);
		cbFluid.setSelectedItem(iSelected);
		cbFluid.setEnabled(! FluidBlocked);
		/*
		 * tfPressure
		 */
		tfPressure.setName("tfPressure");
		tfPressure.setSize(90, 20);
		tfPressure.setLocation(175, 45);
		tfPressure.addKeyListener(this);
		/*
		 * tfTem
		 */
		tfTem.setName("tfTem");
		tfTem.setSize(90, 20);
		tfTem.setLocation(175, 70);
		tfTem.addKeyListener(this);
		/*
		 * tfXCon
		 */
		tfXCon.setName("tfXCon");
		tfXCon.setSize(90, 20);
		tfXCon.setLocation(175, 95);
		tfXCon.addKeyListener(this);
		/*
		 * tfMF
		 */
		tfMF.setName("tfMF");
		tfMF.setSize(90, 20);
		tfMF.setLocation(175, 120);
		tfMF.addKeyListener(this);
		/*
		 * btAccept
		 */
		btAccept.setName("btAccept");
		btAccept.setText("Aceptar");
		btAccept.setSize(90, 25);
		btAccept.setLocation(60, 170);
		btAccept.addActionListener(this);
		/*
		 * btCancel
		 */
		btCancel.setName("btCancel");
		btCancel.setText("Cancelar");
		btCancel.setSize(90, 25);
		btCancel.setLocation(175, 170);
		btCancel.addActionListener(this);
		/*
		 * GNode
		 */
		this.setTitle("Nodo");
		this.setSize(300, 250);
		this.setLocationRelativeTo(myParent);
		this.setResizable(false);
		this.setModalityType(ModalityType.APPLICATION_MODAL);
		this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		this.setLayout(null);
		this.addKeyListener(DialogKey);
		this.add(lbFluid);
		this.add(lbPressure);
		this.add(lbTem);
		this.add(lbXCon);
		this.add(lbMF);
		this.add(cbFluid);
		this.add(tfPressure);
		this.add(tfTem);
		this.add(tfXCon);
		this.add(tfMF);
		this.add(btAccept);
		this.add(btCancel);
	}
	
	public boolean getDialogResult(){
		return dialogResult;
	}
	
	@Override
	public void actionPerformed(ActionEvent e){
		if(e.getSource() == btAccept){
			dialogResult = true;
			this.setVisible(false);
		} else if (e.getSource() == btCancel){
			dialogResult = false;
			this.setVisible(false);
		}
	}
	
	@Override
	public void keyTyped(KeyEvent e) {
		if (HandleKeyEvent(e)) {
			e.consume();
		}	
	}

	@Override
	public void keyPressed(KeyEvent e) {
		if (HandleKeyEvent(e)) {
			e.consume();
		}
	}

	@Override
	public void keyReleased(KeyEvent e) {
		if (HandleKeyEvent(e)) {
			e.consume();
		}
	}
	
	public boolean HandleKeyEvent(KeyEvent e) {
		boolean Handled = false;
		JTextField ObjTextBox = (JTextField) e.getSource();
		if (e.getKeyCode() == KeyEvent.VK_ENTER){
			dialogResult = true;
			this.setVisible(false);
		} else if(e.getKeyCode() == KeyEvent.VK_ESCAPE){
			dialogResult = false;
			this.setVisible(false);
		} else if (e.getKeyCode() == KeyEvent.VK_BACK_SPACE) {
			if (ObjTextBox.getText().length() < 1 || (ObjTextBox.getSelectionEnd() - ObjTextBox.getSelectionStart()) == ObjTextBox.getText().length()){
				ObjTextBox.setText("0.0");
				ObjTextBox.setSelectionStart(0);
				ObjTextBox.setSelectionEnd(ObjTextBox.getText().length());
				Handled = true;
			} else {
				Handled = false;
			}
		} else if ((e.getKeyChar() == '.' || e.getKeyChar() == ',')) {
			if (ObjTextBox.getText().indexOf('.') != -1) {
				Handled = true;
			} else {
				e.setKeyChar('.');
				Handled = false;
			}
		} else if (e.getKeyChar() == '+') {
			if (ObjTextBox.getText().contains("-")){
				ObjTextBox.setText(ObjTextBox.getText().substring(1, ObjTextBox.getText().length()));
			}
			Handled = true;
		} else if (e.getKeyChar() == '-') {
			if (! ObjTextBox.getText().contains("-")){
				ObjTextBox.setText("-" + ObjTextBox.getText());
			}
			Handled = true;
		} else if (e.getKeyChar() < '0' || e.getKeyChar() > '9') {
			// Desechar los caracteres que no son dgitos
			Handled = true;
		}
	return Handled;
	}
	
	public static Node getData(JFrame parent, String title, Node node, Modality mode){
		GNode form;
		if (mode == Modality.ALL_MODIFIABLE){
			form = new GNode(parent);
			form.setTitle(title);
		} else if (mode == Modality.KEEP_FLUID){
			form = new GNode(parent, node);
			form.setTitle(title);
		} else if (mode == Modality.KEEP_XCON){
			form = new GNode(parent, node);
			form.setTitle(title);
			form.tfPressure.setEnabled(false);
			form.tfXCon.setEnabled(false);
		} else if (mode == Modality.KEEP_PRESSURE) {
			form = new GNode(parent, node);
			form.setTitle(title);
			form.tfPressure.setEnabled(false);
		} else { //mode.Modality.ONLY_READING
			form = new GNode(parent, node);
			form.setTitle(title);
			form.tfPressure.setEnabled(false);
			form.tfTem.setEnabled(false);
			form.tfXCon.setEnabled(false);
			form.tfMF.setEnabled(false);
		}
		if (node.getFluid().getName() == "Air"){
			form.cbFluid.setSelectedIndex(0);
		} else if (node.getFluid().getName() == "Water"){
			form.cbFluid.setSelectedIndex(1);
			form.lbXCon.setVisible(false);
			form.tfXCon.setVisible(false);
		} else { // Desiccant
			form.cbFluid.setSelectedIndex(2);
		}
		form.tfPressure.setText(String.format(Locale.US, "%.4f", node.getPressure()));
		form.tfTem.setText(String.format(Locale.US, "%.4f", node.getTem()));
		form.tfXCon.setText(String.format(Locale.US, "%.4f", node.getXCon() * 1000.0));
		form.tfMF.setText(String.format(Locale.US, "%.4f", node.getMFlow() * 3600.0));
		form.setVisible(true);
		if (form.getDialogResult()){
			switch (form.cbFluid.getSelectedIndex()) {
				case 0: // Air
					node.setFluid(new Air());
					break;
				case 1: // Water
					node.setFluid(new Water());
					break;
				default: // Desiccant
					node.setFluid(new Desiccant());
					break;
			}
			node.setPressure(Double.valueOf(form.tfPressure.getText()));
			node.setTem(Double.valueOf(form.tfTem.getText()));
			node.setXCon(Double.valueOf(form.tfXCon.getText()) / 1000.0);
			node.setMFlow(Double.valueOf(form.tfMF.getText()) / 3600.0);
		}
		return node;
	}
	
}
