package SIM;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Locale;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import Elements.PumpPerformedCurve;

public class GPPC extends JDialog  implements ActionListener{
	// Components
	private JLabel lbQmin;
	private JLabel lbQmax;
	private JLabel lbQBEP;
	private JLabel lbPsi;
	private JLabel lbC0;
	private JLabel lbC1;
	private JLabel lbC2;
	private JLabel lbC3;
	private JLabel lbC4;
	private JLabel lbN;
	private JLabel lbD;
	private JTextField txtQmin;
	private JTextField txtQmax;
	private JTextField txtQBEP;
	private JTextField txtC0;
	private JTextField txtC1;
	private JTextField txtC2;
	private JTextField txtC3;
	private JTextField txtC4;
	private JTextField txtN;
	private JTextField txtD;
	private JButton btAccept;
	private JButton btCancel;
	private boolean dialogResult;
	private PumpPerformedCurve ppc;
	
	public GPPC(JDialog parent){
		InitializeComponents(parent);
	}
	
	public void InitializeEvents(){
		
	}
	
	public void InitializeComponents(JDialog myParent){
		lbQmin = new JLabel();
		lbQmax = new JLabel();
		lbQBEP = new JLabel();
		lbPsi = new JLabel();
		lbC0 = new JLabel();
		lbC1 = new JLabel();
		lbC2 = new JLabel();
		lbC3 = new JLabel();
		lbC4 = new JLabel();
		lbN = new JLabel();
		lbD = new JLabel();
		txtQmin = new JTextField();
		txtQmax = new JTextField();
		txtQBEP = new JTextField();
		txtC0 = new JTextField();
		txtC1 = new JTextField();
		txtC2 = new JTextField();
		txtC3 = new JTextField();
		txtC4 = new JTextField();
		txtN = new JTextField();
		txtD = new JTextField();
		btAccept = new JButton();
		btCancel = new JButton();
		ppc = new PumpPerformedCurve();
		/*
		 * lbQmin
		 */
		lbQmin.setName("lbQmin");
		lbQmin.setText("Caudal mnimo (L/min):");
		lbQmin.setSize(150, 18);
		lbQmin.setLocation(10, 11);
		/*
		 * lbQmax
		 */
		lbQmax.setName("lbQmax");
		lbQmax.setText("Caudal mximo (L/min):");
		lbQmax.setSize(150, 18);
		lbQmax.setLocation(10, 41);
		/*
		 * lbQBEP
		 */
		lbQBEP.setName("lbQBEP");
		lbQBEP.setText("Caudal de diseo (L/min):");
		lbQBEP.setSize(150, 18);
		lbQBEP.setLocation(10, 71);
		/*
		 * lbPsi
		 */
		lbPsi.setName("lbPsi");
		lbPsi.setText("\u03C8" + " = ");
		lbPsi.setSize(80, 18);
		lbPsi.setLocation(10, 121);
		/*
		 * lbC0
		 */
		lbC0.setName("lbC0");
		lbC0.setText(" + ");
		lbC0.setSize(20, 18);
		lbC0.setLocation(84, 121);
		/*
		 * lbC1
		 */
		lbC1.setName("lbC1");
		lbC1.setText(" * \u03C6 + ");
		lbC1.setSize(80, 18);
		lbC1.setLocation(152, 121);
		/*
		 * lbC2
		 */
		lbC2.setName("lbC2");
		lbC2.setText(" * \u03C6^2 + ");
		lbC2.setSize(80, 18);
		lbC2.setLocation(240, 121);
		/*
		 * lbC3
		 */
		lbC3.setName("lbC3");
		lbC3.setText(" + \u03C6^3 + ");
		lbC3.setSize(80, 18);
		lbC3.setLocation(342, 121);
		/*
		 * lbC4
		 */
		lbC4.setName("lbC4");
		lbC4.setText(" + \u03C6^4");
		lbC4.setSize(80, 18);
		lbC4.setLocation(445, 121);
		/*
		 * lbN
		 */
		lbN.setName("lbN");
		lbN.setText("Revoluciones del rodete (Hz):");
		lbN.setSize(170, 18);
		lbN.setLocation(250, 11);
		/*
		 * lbD
		 */
		lbD.setName("lbD");
		lbD.setText("Dimetro del rodete (mm):");
		lbD.setSize(170, 18);
		lbD.setLocation(250, 41);
		/*
		 * txtQmin
		 */
		txtQmin.setName("txtQmin");
		txtQmin.setSize(50, 20);
		txtQmin.setLocation(170, 10);
		/*
		 * txtQmax
		 */
		txtQmax.setName("txtQmax");
		txtQmax.setSize(50, 20);
		txtQmax.setLocation(170, 40);
		/*
		 * txtQBEP
		 */
		txtQBEP.setName("txtQBEP");
		txtQBEP.setSize(50, 20);
		txtQBEP.setLocation(170, 70);
		/*
		 * txtC0
		 */
		txtC0.setName("txtC0");
		txtC0.setSize(45, 20);
		txtC0.setLocation(35, 120);
		/*
		 * txtC1
		 */
		txtC1.setName("txtC1");
		txtC1.setSize(45, 20);
		txtC1.setLocation(102, 120);
		/*
		 * txtC2
		 */
		txtC2.setName("txtC2");
		txtC2.setSize(45, 20);
		txtC2.setLocation(190, 120);
		/*
		 * txtC3
		 */
		txtC3.setName("txtC3");
		txtC3.setSize(45, 20);
		txtC3.setLocation(292, 120);
		/*
		 * txtC4
		 */
		txtC4.setName("txtC4");
		txtC4.setSize(45, 20);
		txtC4.setLocation(396, 120);
		/*
		 * txtN
		 */
		txtN.setName("txtN");
		txtN.setSize(50, 20);
		txtN.setLocation(430, 10);
		/*
		 * txtD
		 */
		txtD.setName("txtD");
		txtD.setSize(50, 20);
		txtD.setLocation(430, 40);
		/*
		 * btAccept
		 */
		btAccept.setName("btAccept");
		btAccept.setText("Aceptar");
		btAccept.setSize(100, 20);
		btAccept.setLocation(260, 160);
		btAccept.addActionListener(this);
		/*
		 * btCancel
		 */
		btCancel.setName("btCancel");
		btCancel.setText("Cancelar");
		btCancel.setSize(100, 20);
		btCancel.setLocation(380, 160);
		btCancel.addActionListener(this);
		/*
		 * GPPC
		 */
		this.setTitle("Curva de desempeo de la bomba");
		this.setSize(500, 220);
		this.setResizable(false);
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.setModalityType(ModalityType.APPLICATION_MODAL);
		this.setLayout(null);
		this.add(lbQmin);
		this.add(lbQmax);
		this.add(lbQBEP);
		this.add(lbPsi);
		this.add(lbC0);
		this.add(lbC1);
		this.add(lbC2);
		this.add(lbC3);
		this.add(lbC4);
		this.add(lbD);
		this.add(lbN);
		this.add(txtQmin);
		this.add(txtQmax);
		this.add(txtQBEP);
		this.add(txtC0);
		this.add(txtC1);
		this.add(txtC2);
		this.add(txtC3);
		this.add(txtC4);
		this.add(txtD);
		this.add(txtN);
		this.add(btAccept);
		this.add(btCancel);
	}
	
	public boolean getDialogResult(){
		return dialogResult;
	}
	
	public static PumpPerformedCurve getData(JDialog parent, PumpPerformedCurve myPPC){
		GPPC form = new GPPC(parent);
		form.txtQmin.setText(String.format(Locale.US, "%.2f", myPPC.getQmin()));
		form.txtQmax.setText(String.format(Locale.US, "%.2f", myPPC.getQmax()));
		form.txtQBEP.setText(String.format(Locale.US, "%.2f", myPPC.getQBEP()));
		form.txtD.setText(String.format(Locale.US, "%.2f", myPPC.getD()));
		form.txtN.setText(String.format(Locale.US, "%.2f", myPPC.getN()));
		form.txtC0.setText(String.format(Locale.US, "%.2f", myPPC.getC()[0]));
		form.txtC1.setText(String.format(Locale.US, "%.2f", myPPC.getC()[1]));
		form.txtC2.setText(String.format(Locale.US, "%.2f", myPPC.getC()[2]));
		form.txtC3.setText(String.format(Locale.US, "%.2f", myPPC.getC()[3]));
		form.txtC4.setText(String.format(Locale.US, "%.2f", myPPC.getC()[4]));
		form.setVisible(true);
		if(form.getDialogResult() == true){
			myPPC.setQmin(Double.valueOf(form.txtQmin.getText()));
			myPPC.setQmax(Double.valueOf(form.txtQmax.getText()));
			myPPC.setQBEP(Double.valueOf(form.txtQBEP.getText()));
			myPPC.setD(Double.valueOf(form.txtD.getText()));
			myPPC.setN(Double.valueOf(form.txtN.getText()));
			double C[] = new double[5];
			C[0] = Double.valueOf(form.txtC0.getText());
			C[1] = Double.valueOf(form.txtC1.getText());
			C[2] = Double.valueOf(form.txtC2.getText());
			C[3] = Double.valueOf(form.txtC3.getText());
			C[4] = Double.valueOf(form.txtC4.getText());
			myPPC.setC(C);
		}
		form.dispose();
		return myPPC;
	}
	
	@Override
	public void actionPerformed(ActionEvent e){
		if(e.getSource() == btAccept){
			if (fill()){
				dialogResult = true;
				this.setVisible(false);
			} else {
			JOptionPane.showMessageDialog(new JPanel(), "Curva no vlida", 
					"Los coeficientes no forman una curva vlida", JOptionPane.ERROR_MESSAGE);
			}
		} else { // e.getSource == btCancelar
			dialogResult = false;
			this.setVisible(false);
		}
	}
	
	private boolean fill(){
		boolean result = true;
		double[] aC = new double[5];
		aC[0] = Double.parseDouble(txtC0.getText());
		aC[1] = Double.parseDouble(txtC1.getText());
		aC[2] = Double.parseDouble(txtC2.getText());
		aC[3] = Double.parseDouble(txtC3.getText());
		aC[4] = Double.parseDouble(txtC4.getText());
		result = ppc.setC(aC);
		return result;
	}
	
}
