package SIM;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Locale;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;

import Elements.Pipe;

public class GPipe extends JDialog implements ActionListener{
	private JLabel lbType;
	private JLabel lbIns;
	private JLabel lbLength;
	private JLabel lbOD;
	private JLabel lbPPThick;
	private JLabel lbKp;
	private JLabel lbPPLF;
	private JLabel lbINThick;
	private JLabel lbKi;
	private JLabel lbHi;
	private JLabel lbHo;
	private JComboBox<String> cbType;
	private JComboBox<String> cbIns;
	private JTextField txtLength;
	private JTextField txtOD;
	private JTextField txtPPThick;
	private JTextField txtKp;
	private JTextField txtPPLF;
	private JTextField txtINThick;
	private JTextField txtKi;
	private JTextField txtHi;
	private JTextField txtHo;
	private JPanel pnlPipe;
	private JPanel pnlIns;
	private JButton btAccept;
	private JButton btCancel;
	private boolean dialogResult;
	private ItemListener Changed;
	
	public GPipe(JFrame parent, String title){
		InitializeEvents();
		InitializeComponents(parent, title);
	}
	
	public void InitializeEvents(){
		Changed = new ItemListener(){
			@Override
			public void itemStateChanged(ItemEvent ev) {
				if(ev.getSource() == cbType){
					switch(cbType.getSelectedIndex()){
					case 0: //CUSTOM
						txtOD.setEnabled(true);
						txtPPThick.setEnabled(true);
						txtKp.setEnabled(true);
						txtPPLF.setEnabled(true);
						break;
					case 1: //PPR_PN16_20OD
						txtOD.setEnabled(false);
						txtOD.setText("20.0");
						txtPPThick.setEnabled(false);
						txtPPThick.setText("2.8");
						txtKp.setEnabled(false);
						txtPPLF.setEnabled(false);
						break;
					case 2: //PPR_PN16_25OD
						txtOD.setEnabled(false);
						txtOD.setText("25.0");
						txtPPThick.setEnabled(false);
						txtPPThick.setText("3.5");
						txtKp.setEnabled(false);
						txtPPLF.setEnabled(false);
						break;
					case 3: //PPR_PN16_32OD
						txtOD.setEnabled(false);
						txtOD.setText("32.0");
						txtPPThick.setEnabled(false);
						txtPPThick.setText("4.5");
						txtKp.setEnabled(false);
						txtPPLF.setEnabled(false);
						break;
					default: //PPR_PN16_40OD
						txtOD.setEnabled(false);
						txtOD.setText("40.0");
						txtPPThick.setEnabled(false);
						txtOD.setText("5.6");
						txtKp.setEnabled(false);
						txtPPLF.setEnabled(false);
						break;
					}
					txtKp.setText("0.24");
					txtPPLF.setText("0.02526");
				}
				if(ev.getSource() == cbIns){
					switch(cbIns.getSelectedIndex()){
					case 0: //CUSTOM
						txtINThick.setEnabled(true);				
						txtKi.setEnabled(true);
						break;
					case 1: //AFX_127
						txtINThick.setEnabled(false);
						txtINThick.setText("12.7");
						txtKi.setEnabled(false);
						break;
					default: //AFX_254
						txtINThick.setEnabled(false);
						txtINThick.setText("25.4");
						txtKi.setEnabled(false);
						break;
					}
					txtKi.setText("0.036");
				}
			}
		};
	}
	
	public void InitializeComponents(JFrame parent, String title){
		lbType = new JLabel();
		lbIns = new JLabel();
		lbLength = new JLabel();
		lbOD = new JLabel();
		lbPPThick = new JLabel();
		lbKp = new JLabel();
		lbPPLF = new JLabel();
		lbINThick = new JLabel();
		lbKi= new JLabel();
		lbHi = new JLabel();
		lbHo = new JLabel();
		cbType = new JComboBox<String>();
		cbIns = new JComboBox<String>();
		txtLength = new JTextField();
		txtOD = new JTextField();
		txtPPThick = new JTextField();
		txtKp = new JTextField();
		txtPPLF = new JTextField();
		txtINThick = new JTextField();
		txtKi = new JTextField();
		txtHi = new JTextField();
		txtHo = new JTextField();
		pnlPipe = new JPanel();
		pnlIns = new JPanel();
		btAccept = new JButton();
		btCancel = new JButton();
		Dimension sizeLB = new Dimension(100, 18);
		Dimension sizeCB = new Dimension(130, 20);
		Dimension sizeTB = new Dimension(80, 20);
		Dimension sizeBT = new Dimension(120, 23);
		
		/*
		 * lbType
		 */
		lbType.setName("lbType");
		lbType.setText("Tipo");
		lbType.setSize(new Dimension(60, 18));
		lbType.setLocation(10, 20);
		
		/*
		 * lbIns
		 */
		lbIns.setName("lbIns");
		lbIns.setText("Tipo");
		lbIns.setSize(new Dimension(60, 18));
		lbIns.setLocation(10, 20);
		
		/*
		 * lbLength
		 */
		lbLength.setName("lbLength");
		lbLength.setText("Longitud");
		lbLength.setSize(sizeLB);
		lbLength.setLocation(250, 150);
		
		/*
		 * lbOD
		 */
		lbOD.setName("lbDO");
		lbOD.setText("Dim. ext. (mm):");
		lbOD.setSize(sizeLB);
		lbOD.setLocation(10, 50);
		
		/*
		 * lbPPThick
		 */
		lbPPThick.setName("lbPPThick");
		lbPPThick.setText("Espesor (mm):");
		lbPPThick.setSize(sizeLB);
		lbPPThick.setLocation(10, 80);
		
		/*
		 * lbKp
		 */
		lbKp.setName("lbKp");
		lbKp.setText("k (W/m-K):");
		lbKp.setSize(sizeLB);
		lbKp.setLocation(10, 110);
		
		/*
		 * lbPPLF
		 */
		lbPPLF.setName("lbPPLF");
		lbPPLF.setText("Coef. de friccin:");
		lbPPLF.setSize(sizeLB);
		lbPPLF.setLocation(10, 140);
		
		/*
		 * lbINThick
		 */
		lbINThick.setName("lbINThick");
		lbINThick.setText("Espesor (mm):");
		lbINThick.setSize(sizeLB);
		lbINThick.setLocation(10, 50);
		
		/*
		 * lbKi
		 */
		lbKi.setName("lbKi");
		lbKi.setText("k (W/m-K):");
		lbKi.setSize(sizeLB);
		lbKi.setLocation(10, 80);
		
		/*
		 * lbHi
		 */
		lbHi.setName("lbHi");
		lbHi.setText("h_i (W/m^2-K):");
		lbHi.setSize(sizeLB);
		lbHi.setLocation(15, 180);
		
		/*
		 * lbHo
		 */
		lbHo.setName("lbHo");
		lbHo.setText("h_oo (W/m^2-K):");
		lbHo.setSize(sizeLB);
		lbHo.setLocation(15, 210);
		
		/*
		 * cbType
		 */
		cbType.setName("CbType");
		cbType.addItem("Personalizado");
		cbType.addItem("PPR_PN16_20OD");
		cbType.addItem("PPR_PN16_250D");
		cbType.addItem("PPR_PN16_320D");
		cbType.addItem("PPR_PN16_400D");
		cbType.setBackground(Color.WHITE);
		cbType.setSize(sizeCB);
		cbType.setLocation(90, 20);
		cbType.addItemListener(Changed);
		
		/*
		 * cbIns
		 */
		cbIns.setName("cbIns");
		cbIns.addItem("Personalizado");
		cbIns.addItem("AFX_127");
		cbIns.addItem("AFX_254");
		cbIns.setBackground(Color.WHITE);
		cbIns.setSize(sizeCB);
		cbIns.setLocation(90, 20);
		cbIns.addItemListener(Changed);
		
		/*
		 * txtLength
		 */
		txtLength.setName("txtLength");
		txtLength.setText("3.0");
		txtLength.setHorizontalAlignment(JTextField.RIGHT);
		txtLength.setSize(sizeTB);
		txtLength.setLocation(380, 150);
		
		/*
		 * txtOD
		 */
		txtOD.setName("txtOD");
		txtOD.setText("25.0");
		txtOD.setHorizontalAlignment(JTextField.RIGHT);
		txtOD.setSize(sizeTB);
		txtOD.setLocation(140, 50);
		
		/*
		 * txtPPThick
		 */
		txtPPThick.setName("txtPPThick");
		txtPPThick.setText("3.5");
		txtPPThick.setHorizontalAlignment(JTextField.RIGHT);
		txtPPThick.setSize(sizeTB);
		txtPPThick.setLocation(140, 80);
		
		/*
		 * txtKp
		 */
		txtKp.setName("txtKp");
		txtKp.setText("0.24");
		txtKp.setHorizontalAlignment(JTextField.RIGHT);
		txtKp.setSize(sizeTB);
		txtKp.setLocation(140, 110);
		
		/*
		 * txtPPLF
		 */
		txtPPLF.setName("txtPPLF");
		txtPPLF.setText("0.02526");
		txtPPLF.setHorizontalAlignment(JTextField.RIGHT);
		txtPPLF.setSize(sizeTB);
		txtPPLF.setLocation(140, 140);
		
		/*
		 * txtINThick
		 */
		txtINThick.setName("txtINThick");
		txtINThick.setText("12.7");
		txtINThick.setHorizontalAlignment(JTextField.RIGHT);
		txtINThick.setSize(sizeTB);
		txtINThick.setLocation(140, 50);
		
		/*
		 * txtKi
		 */
		txtKi.setName("txtKi");
		txtKi.setText("0.036");
		txtKi.setHorizontalAlignment(JTextField.RIGHT);
		txtKi.setSize(sizeTB);
		txtKi.setLocation(140, 80);
		
		/*
		 * txtHi
		 */
		txtHi.setName("txtHi");
		txtHi.setHorizontalAlignment(JTextField.RIGHT);
		txtHi.setSize(sizeTB);
		txtHi.setLocation(120, 180);
		
		/*
		 * txtHo
		 */
		txtHo.setName("txtHo");
		txtHo.setHorizontalAlignment(JTextField.RIGHT);
		txtHo.setSize(sizeTB);
		txtHo.setLocation(120, 210);
		
		/*
		 * pnlPipe
		 */
		pnlPipe.setName("pnlPipe");
		pnlPipe.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED), "Tubera"));
		pnlPipe.setSize(230, 170);
		pnlPipe.setLocation(10, 10);
		pnlPipe.setLayout(null);
		pnlPipe.add(lbType);
		pnlPipe.add(lbOD);
		pnlPipe.add(lbPPThick);
		pnlPipe.add(lbKp);
		pnlPipe.add(lbPPLF);
		pnlPipe.add(cbType);
		pnlPipe.add(txtOD);
		pnlPipe.add(txtPPThick);
		pnlPipe.add(txtKp);
		pnlPipe.add(txtPPLF);
		
		/*
		 * pnlIns
		 */
		pnlIns.setName("pnlIns");
		pnlIns.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED), "Aislamiento"));
		pnlIns.setSize(230, 110);
		pnlIns.setLocation(240, 10);
		pnlIns.setLayout(null);
		pnlIns.add(lbIns);
		pnlIns.add(lbINThick);
		pnlIns.add(lbKi);
		pnlIns.add(cbIns);
		pnlIns.add(txtINThick);
		pnlIns.add(txtKi);
		
		/*
		 * btAccept
		 */
		btAccept.setName("btAccept");
		btAccept.setText("Aceptar");
		btAccept.setSize(sizeBT);
		btAccept.setLocation(220, 210);
		btAccept.addActionListener(this);
		
		/*
		 * btCancel
		 */
		btCancel.setName("btCancel");
		btCancel.setText("Cancelar");
		btCancel.setSize(sizeBT);
		btCancel.setLocation(350, 210);
		btCancel.addActionListener(this);
		
		/*
		 * GPipe
		 */
		this.setTitle(title);
		this.setLayout(null);
		this.setSize(500, 290);
		this.setLocationRelativeTo(parent);
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.setModalityType(ModalityType.APPLICATION_MODAL);
		this.add(pnlPipe);
		this.add(pnlIns);
		this.add(lbLength);
		this.add(lbHi);
		this.add(lbHo);
		this.add(txtLength);
		this.add(txtHi);
		this.add(txtHo);
		this.add(btAccept);
		this.add(btCancel);
	}
	
	public static Pipe showDialog(JFrame parent, String title, Pipe p){
		GPipe form = new GPipe(parent, title);
		switch (p.getType()){
		case CUSTOM :
			form.cbType.setSelectedIndex(0);
			form.txtOD.setText(String.format(Locale.US, "%.4f", p.getOD()));
			form.txtPPThick.setText(String.format(Locale.US, "%.2f", p.getPpThick()));
			form.txtKp.setText(String.format(Locale.US, "%.2f", p.getPpThCond()));
			form.txtPPLF.setText(String.format(Locale.US, "%.2f", p.getPpLFactor()));
			break;
		case PPR_PN16_20OD :
			form.cbType.setSelectedIndex(1);
			break;
		case PPR_PN16_25OD :
			form.cbType.setSelectedIndex(2);
			break;
		case PPR_PN16_32OD :
			form.cbType.setSelectedIndex(3);
			break;
		default :
			form.cbType.setSelectedIndex(4);
			break;
		}
			
		if (p.getInsulation() == Pipe.Insulation.CUSTOM){
			form.cbIns.setSelectedIndex(0);
			form.txtINThick.setText(String.format(Locale.US, "%.2f", p.getInThick()));
			form.txtKi.setText(String.format(Locale.US, "%.2f", p.getInThCond()));
		} else if (p.getInsulation() == Pipe.Insulation.AFX_127){
			form.cbIns.setSelectedIndex(1);
		} else if (p.getInsulation() == Pipe.Insulation.AFX_254){
			form.cbIns.setSelectedIndex(2);
		}
		form.txtHi.setText(String.format(Locale.US, "%.2f", p.getHf()));
		form.txtHo.setText(String.format(Locale.US, "%.2f", p.getHoo()));
		form.txtLength.setText(String.format(Locale.US, "%.2f", p.getLength()));
		form.setVisible(true);
		if (form.getDialogResult()){
			switch(form.cbType.getSelectedIndex()){
			case 0 :
				p.setType(Pipe.Type.CUSTOM);
				p.setOD(Double.valueOf(form.txtOD.getText()) / 1000.0);
				p.setPpThick(Double.valueOf(form.txtPPThick.getText()) / 1000.0);
				p.setPpThCond(Double.valueOf(form.txtKp.getText()));
				p.setPpLFactor(Double.valueOf(form.txtPPLF.getText()));
				break;
			case 1 :
				p.setType(Pipe.Type.PPR_PN16_20OD);
				break;
			case 2 :
				p.setType(Pipe.Type.PPR_PN16_25OD);
				break;
			case 3 :
				p.setType(Pipe.Type.PPR_PN16_32OD);
				break;
			default :
				p.setType(Pipe.Type.PPR_PN16_40OD);
				break;
			}
			if (form.cbIns.getSelectedIndex() == 0){
				p.setInsulation(Pipe.Insulation.CUSTOM);
				p.setInThick(Double.valueOf(form.txtINThick.getText()) / 1000.0);
				p.setInThCond(Double.valueOf(form.txtKi.getText()));
			} else if (form.cbIns.getSelectedIndex() == 1) {
				p.setInsulation(Pipe.Insulation.AFX_127);
			} else {
				p.setInsulation(Pipe.Insulation.AFX_254);
			}
			p.setHf(Double.valueOf(form.txtHi.getText()));
			p.setHoo(Double.valueOf(form.txtHo.getText()));
			p.setLength(Double.valueOf(form.txtLength.getText()));
		}
		return p;
	}
	
	public boolean getDialogResult(){
		return dialogResult;
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == btAccept){
			dialogResult = true;
			this.setVisible(false);
		} else { // e.getSource == btCancelar
			dialogResult = false;
			this.setVisible(false);
		}	
	}
}
