package SIM;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Locale;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;

import Elements.Pump;
import Elements.PumpPerformedCurve;

public class GPump extends JDialog implements ActionListener, ItemListener{
	private JLabel lbESH;
	private JLabel lbEMT;
	private JTextField txtESH;
	private JTextField txtEMT;
	private JCheckBox cbFixed;
	private JButton btPPC;
	private JButton btAccept;
	private JButton btCancel;
	private PumpPerformedCurve a_ppc;
	private boolean dialogResult;
	
	public GPump(JFrame parent, String title){
		InitializeEvents();
		InitializeComponents(parent, title);
	}
	public void InitializeEvents(){
		
	}
	
	public void InitializeComponents(JFrame myParent, String title){
		lbESH = new JLabel();
		lbEMT = new JLabel();
		txtESH = new JTextField();
		txtEMT = new JTextField();
		cbFixed = new JCheckBox();
		btPPC = new JButton();
		btAccept = new JButton();
		btCancel = new JButton();
		a_ppc = new PumpPerformedCurve();
		/*
		 * lbESH
		 */
		lbESH.setName("lbESH");
		lbESH.setText("Eficiencia de eje (%): ");
		lbESH.setSize(150, 18);
		lbESH.setLocation(10, 11);
		/*
		 * lbEMT
		 */
		lbEMT.setName("lbEMT");
		lbEMT.setText("Eficiencia de motor (%): ");
		lbEMT.setSize(150, 18);
		lbEMT.setLocation(10,  41);
		/*
		 * txtESH
		 */
		txtESH.setName("txtESH");
		txtESH.setSize(30, 20);
		txtESH.setLocation(160, 10);
		/*
		 * txtEMT
		 */
		txtEMT.setName("txtEMT");
		txtEMT.setSize(30, 20);
		txtEMT.setLocation(160, 40);
		/*
		 * cbFixed
		 */
		cbFixed.setName("CbFixed");
		cbFixed.setText("Curva de desempeo");
		cbFixed.setSize(160, 20);
		cbFixed.setLocation(25, 70);
		cbFixed.addItemListener(this);
		/*
		 * btPPC
		 */
		btPPC.setName("btPPC");
		btPPC.setText("Definir curva");
		btPPC.setSize(170, 20);
		btPPC.setLocation(10, 110);
		btPPC.addActionListener(this);
		btPPC.setEnabled(false);
		/*
		 * btCancel
		 */
		btCancel.setName("btCancel");
		btCancel.setText("Cancelar");
		btCancel.setSize(100, 20);
		btCancel.setLocation(80, 180);
		btCancel.addActionListener(this);
		/*
		 * btAccept
		 */
		btAccept.setName("BtAccept");
		btAccept.setText("Aceptar");
		btAccept.setSize(100, 20);
		btAccept.setLocation(80, 150);
		btAccept.addActionListener(this);
		/*
		 * GPump
		 */
		this.setTitle(title);
		this.setSize(200, 250);
		this.setResizable(false);
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.setModalityType(ModalityType.APPLICATION_MODAL);
		this.setLocationRelativeTo(myParent);
		this.setLayout(null);
		this.add(lbEMT);
		this.add(lbESH);
		this.add(txtESH);
		this.add(txtEMT);
		this.add(cbFixed);
		this.add(btPPC);
		this.add(btAccept);
		this.add(btCancel);
	}
	
	public static Pump getData(JFrame parent, String title, Pump p){
		GPump form = new GPump(parent, title);
		form.txtESH.setText(String.format(Locale.US, "%.2f", p.getESH()));
		form.txtEMT.setText(String.format(Locale.US, "%.2f", p.getEMT()));
		form.setPPC(p.getPPC());
		form.setVisible(true);
		if(form.getDialogResult() == true){
			p.setESH(Double.parseDouble(form.txtESH.getText()));
			p.setEMT(Double.parseDouble(form.txtEMT.getText()));
			p.setPPC(form.getPPC());
		}
		return p;
	}
	
	public void setPPC(PumpPerformedCurve ppc){
		a_ppc = ppc;
	}
	
	public PumpPerformedCurve getPPC(){
		return a_ppc;
	}
	
	public boolean getDialogResult(){
		return dialogResult;
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == btPPC){
			a_ppc = GPPC.getData(this, a_ppc);
		} else if(e.getSource() == btAccept){
			dialogResult = true;
			this.setVisible(false);
		} else { //e.getSource() == btCancel
			dialogResult = false;
			this.setVisible(false);
		}
		
	}
	
	@Override
	public void itemStateChanged(ItemEvent e) {
			btPPC.setEnabled(cbFixed.isSelected());
	}
}
