package SIM;

import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JPanel;
import java.awt.event.ActionListener;
import java.awt.Dimension;
import java.awt.event.ActionEvent;

public class GReport extends JDialog implements ActionListener{
	/**
	 * 
	 */
	private static final long serialVersionUID = 8645728469849373453L;
	protected JLabel lbPath;
	protected JLabel lbTi;
	protected JLabel lbTf;
	protected JLabel lbRHi;
	protected JLabel lbRHf;
	protected JTextField tfPath;
	protected JTextField tfTi;
	protected JTextField tfTf;
	protected JTextField tfRHi;
	protected JTextField tfRHf;
	protected JPanel pbOA;
	protected JButton btChange;
	protected JButton btGenerate;
	protected JButton btCancel;
	protected JFileChooser fc;
	protected boolean DialogResult;
	
	public void InitializeEvents(){
		
	}
	
	public void InitializeComponents(){
		lbPath = new JLabel();
		lbTi = new JLabel();
		lbTf = new JLabel();
		lbRHi = new JLabel();
		lbRHf = new JLabel();
		tfPath = new JTextField();
		tfTi = new JTextField();
		tfTf = new JTextField();
		tfRHi = new JTextField();
		tfRHf = new JTextField();
		pbOA = new JPanel();
		btChange = new JButton();
		btGenerate = new JButton();
		btCancel = new JButton();
		fc = new JFileChooser();
		Dimension lbSize = new Dimension(140, 18);
		Dimension tfSize = new Dimension(50, 18);
		Dimension btSize = new Dimension(100, 20);
		/*
		 * lbPath
		 */
		lbPath.setName("lbPath");
		lbPath.setText("Destino:");
		lbPath.setSize(lbSize);
		lbPath.setLocation(10, 11);
		/*
		 * lbTi
		 */
		lbTi.setName("lbTi");
		lbTi.setText("Temperatura inicial (C)");
		lbTi.setSize(lbSize);
		lbTi.setLocation(20, 20);
		/*
		 * lbTf
		 */
		lbTf.setName("lbTf");
		lbTf.setText("Temperatura final (C)");
		lbTf.setSize(lbSize);
		lbTf.setLocation(20, 40);
		/*
		 * lbRHi
		 */
		lbRHi.setName("lbRHi");
		lbRHi.setText("Humedad relativa inicial (%)");
		lbRHi.setSize(lbSize);
		lbRHi.setLocation(250, 20);
		/*
		 * lbRHf
		 */
		lbRHf.setName("lbRHf");
		lbRHf.setText("Humedad relativa final (%)");
		lbRHf.setSize(lbSize);
		lbRHf.setLocation(250, 40);
		/*
		 * tfPath
		 */
		tfPath.setName("tfPath");
		tfPath.setText("C://report.tsv");
		tfPath.setSize(300, 18);
		tfPath.setLocation(70, 11);
		/*
		 * tfTi
		 */
		tfTi.setName("tfTi");
		tfTi.setText("20.0");
		tfTi.setSize(tfSize);
		tfTi.setLocation(160, 20);
		/*
		 * tfTf
		 */
		tfTf.setName("tfTf");
		tfTf.setText("40.0");
		tfTf.setSize(tfSize);
		tfTf.setLocation(160, 40);
		/*
		 * tfRHi
		 */
		tfRHi.setName("tfRHi");
		tfRHi.setText("70.0");
		tfRHi.setSize(tfSize);
		tfRHi.setLocation(400, 20);
		/*
		 * tfRHf
		 */
		tfRHf.setName("tfRHf");
		tfRHf.setText("100.0");
		tfRHf.setSize(tfSize);
		tfRHf.setLocation(400, 40);
		/*
		 * pbOA
		 */
		pbOA.setName("pbOA");
		pbOA.setBorder(BorderFactory.createTitledBorder("Aire Exterior"));
		pbOA.setSize(470, 80);
		pbOA.setLocation(10, 40);
		pbOA.setLayout(null);
		pbOA.add(lbTi);
		pbOA.add(lbTf);
		pbOA.add(lbRHi);
		pbOA.add(lbRHf);
		pbOA.add(tfTi);
		pbOA.add(tfTf);
		pbOA.add(tfRHi);
		pbOA.add(tfRHf);
		/*
		 * btChange
		 */
		btChange.setName("btChange");
		btChange.setText("Cambiar");
		btChange.setSize(btSize);
		btChange.setLocation(380, 10);
		btChange.addActionListener(this);
		/*
		 * btGenerate
		 */
		btGenerate.setName("btGenerate");
		btGenerate.setText("Generar");
		btGenerate.setSize(btSize);
		btGenerate.setLocation(260, 130);
		btGenerate.addActionListener(this);
		/*
		 * btCancel
		 */
		btCancel.setName("btCancel");
		btCancel.setText("Cancelar");
		btCancel.setSize(btSize);
		btCancel.setLocation(380, 130);
		btCancel.addActionListener(this);
		/*
		 * fc
		 */
		fc.addChoosableFileFilter(new SimFileFilter());
		fc.setAcceptAllFileFilterUsed(false);
		/*
		 * GReport
		 */
		this.setTitle("Reporte");
		this.setLayout(null);
		this.setSize(500,190);
		this.setResizable(false);
		this.setModalityType(ModalityType.APPLICATION_MODAL);
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.add(lbPath);
		this.add(tfPath);
		this.add(pbOA);
		this.add(btChange);
		this.add(btCancel);
		this.add(btGenerate);
	}
	
	public GReport(){
		InitializeEvents();
		InitializeComponents();
		DialogResult = false;
	}
	
	
	public boolean getDialogResult(){
		return DialogResult;
	}
	
	public static boolean showDialog(GSim parent){
		GReport form = new GReport();
		form.setLocationRelativeTo(form);
		form.setVisible(true);
		parent.range[0][0] = Double.valueOf(form.tfTi.getText());
		parent.range[0][1] = Double.valueOf(form.tfTf.getText());
		parent.range[1][0] = Double.valueOf(form.tfRHi.getText()) / 100.0;
		parent.range[1][1] = Double.valueOf(form.tfRHf.getText()) / 100.0;
		parent.filepath = form.tfPath.getText();
		return form.getDialogResult();
	}
	
	@Override
	public void actionPerformed(ActionEvent e){
		if (e.getSource() == btChange){
			int returnVal = fc.showSaveDialog(GReport.this);
			if (returnVal == JFileChooser.APPROVE_OPTION){
				tfPath.setText(fc.getSelectedFile().getPath());
			}
		} else if (e.getSource() == btCancel){
			DialogResult = false;
			this.setVisible(false);
		} else if (e.getSource() == btGenerate){
			DialogResult = true;
			this.setVisible(false);
		}
	}
	
	public static void main(String[] args){
		GReport form = new GReport();
		form.setVisible(true);
	}
}
