package SIM;
import Elements.*;

import javax.swing.JFrame;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.ProgressMonitor;
import javax.swing.SwingWorker;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Toolkit;
import java.net.URL;
import java.util.Locale;
import java.util.Random;
import java.awt.BorderLayout;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.FileWriter;
import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

public class GSim extends JFrame implements ActionListener, ItemListener, PropertyChangeListener{
	/**
	 * 
	 */
	private static final long serialVersionUID = -3454441905468750942L;
	// Elements
	Node lineT;
	Node lineW;
	Node lineS;
	Node lineX;
	Node lineC;
	// Components
	BufferedImage myImage1;
	JMenuBar myMenu;
	JMenu myFile;
	JMenu myTools;
	JMenu mySet;
	JMenu myHX;
	JMenu myPipe;
	JMenuItem btClose;
	JMenuItem btAbout;
	JMenuItem btHXA;
	JMenuItem btHXK;
	JMenuItem btHXG;
	JMenuItem btLAMEED;
	JMenuItem btLAMEER;
	JMenuItem btPump;
	JMenuItem btPPDP;
	JMenuItem btPPPA;
	JMenuItem btPPAG;
	JMenuItem btPPGR;
	JMenuItem btPPRA;
	JMenuItem btPPAK;
	JMenuItem btPPKD;
	JMenuItem btOA;
	JMenuItem btRA;
	JMenuItem btWKI;
	JMenuItem btSGI;
	JMenuItem btIN;
	JLabel lbNwKo;
	JLabel lbNsGo;
	JLabel lbNtDo;
	JLabel lbNxRo;
	JLabel lbNhDo;
	JLabel lbNcRo;
	ButtonGroup bgUnit;
	JRadioButton rbTem;
	JRadioButton rbHum;
	JRadioButton rbPre;
	JRadioButton rbCon;
	JRadioButton rbMF;
	JButton btSim;
	JButton btReport;
	JPanel PictureBox1;
	JPanel Container;
	GProgressMonitor progressMonitor;
	
	//Properties
	Sim mySim;
	double[][] range;
	String filepath;
	Dimension dimButton;
	Dimension dimLabel;
	Dimension dimTextField;
	Dimension dimRButton;
	boolean unitStatus;
	boolean repRes;
	
	public GSim(){
		super();
		InitImage();
		mySim = new Sim4();
		try{
			mySim.setN_tDi(new Node(new Air(), 20.0, 0.012 / 1.012, 5.0 / 3600.0));
			mySim.setN_xRi(new Node(new Air(), 25.0, 0.0125 / 1.0125, 5.0 / 3600.0));
			mySim.setN_wKi(new Node(new Water(), 15.0, 0.0, 10.0 / 3600.0));
			mySim.setN_sGi(new Node(new Water(), 70.0, 0.0, 10.0 / 3600.0));
			mySim.setN_cKi(new Node(new Desiccant(), 15.0, 0.1, 10.0 / 3600.0));
			mySim.setEp_A(0.8);
			mySim.setEp_K(0.8);
			mySim.setEp_G(0.8);
			mySim.setEp_D(0.8, 0.8);
			mySim.setEp_R(0.8, 0.8);
		} catch (OutOfRangeException ex){
			JOptionPane.showMessageDialog(this, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
		}
		dimButton = new Dimension(100,20);
		dimLabel = new Dimension(80,20);
		dimTextField = new Dimension(50,20);
		dimRButton = new Dimension(120,20);
		filepath = "";
		range = new double[2][2];
		InitializeEvents();
		InitializeComponents();
	}
	
	public void InitializeEvents(){
		
	}
	
	public void InitializeComponents(){
		btClose = new JMenuItem();
		btAbout = new JMenuItem();
		btHXA = new JMenuItem();
		btHXK = new JMenuItem();
		btHXG = new JMenuItem();
		btLAMEED = new JMenuItem();
		btLAMEER = new JMenuItem();
		btPump = new JMenuItem();
		btPPDP = new JMenuItem();
		btPPPA = new JMenuItem();
		btPPAG = new JMenuItem();
		btPPGR = new JMenuItem();
		btPPRA = new JMenuItem();
		btPPAK = new JMenuItem();
		btPPKD = new JMenuItem();
		btOA = new JMenuItem();
		btRA = new JMenuItem();
		btWKI = new JMenuItem();
		btSGI = new JMenuItem();
		btIN = new JMenuItem();
		myHX = new JMenu();
		myPipe = new JMenu();
		myFile = new JMenu();
		myTools = new JMenu();
		mySet = new JMenu();
		myMenu = new JMenuBar();
		lbNwKo = new JLabel();
		lbNsGo = new JLabel();
		lbNtDo = new JLabel();
		lbNxRo = new JLabel();
		lbNhDo = new JLabel();
		lbNcRo = new JLabel();
		rbTem = new JRadioButton();
		rbHum = new JRadioButton();
		rbCon = new JRadioButton();
		rbPre = new JRadioButton();
		rbMF = new JRadioButton();
		bgUnit = new ButtonGroup();
		btSim = new JButton();
		btReport = new JButton();
		PictureBox1 = new JPanel(){
			/**
			 * 
			 */
			private static final long serialVersionUID = -647994439502362041L;

			@Override
			public void paintComponent(Graphics g){
				super.paintComponent(g);
				g.drawImage(myImage1, 0, 0, null);
			}
		};
		Container = new JPanel();
		
		/*
		 * btClose
		 */
		btClose.setName("btClose");
		btClose.setText("Cerrar");
		btClose.addActionListener(this);
		
		/*
		 * btAbout
		 */
		btAbout.setName("btAbout");
		btAbout.setText("Acerca de...");
		btAbout.addActionListener(this);
		
		/*
		 * btHXA
		 */
		btHXA.setName("btHXA");
		btHXA.setText("HX A");
		btHXA.addActionListener(this);
		
		/*
		 * btHXK
		 */
		btHXK.setName("btHXK");
		btHXK.setText("HX K");
		btHXK.addActionListener(this);
		
		/*
		 * btHXG
		 */
		btHXG.setName("btHXG");
		btHXG.setText("HX G");
		btHXG.addActionListener(this);
		
		/*
		 * btLAMEED
		 */
		btLAMEED.setName("btLAMEED");
		btLAMEED.setText("LAMEE D");
		btLAMEED.addActionListener(this);
		
		/*
		 * btLAMEER
		 */
		btLAMEER.setName("btLAMEER");
		btLAMEER.setText("LAMEE R");
		btLAMEER.addActionListener(this);
		
		/*
		 * btOA 
		 */
		btOA.setName("btOA");
		btOA.setText("Aire exterior");
		btOA.addActionListener(this);
		
		/*
		 * btRA
		 */
		btRA.setName("btXA");
		btRA.setText("Aire retorno");
		btRA.addActionListener(this);
		
		/*
		 * btWKI
		 */
		btWKI.setName("btWKI");
		btWKI.setText("Preenfriamiento");
		btWKI.addActionListener(this);
		
		/*
		 * btSGI
		 */
		btSGI.setName("btSGI");
		btSGI.setText("Precalentamiento");
		btSGI.addActionListener(this);
		
		/*
		 * btIN
		 */
		btIN.setName("btIN");
		btIN.setText("Lnea desecante");
		btIN.addActionListener(this);
		
		/*
		 * btPump
		 */
		btPump.setName("btPump");
		btPump.setText("Bomba");
		btPump.addActionListener(this);
		
		/*
		 * btPPDP
		 */
		btPPDP.setName("btPPDP");
		btPPDP.setText("DP");
		btPPDP.addActionListener(this);
		
		/*
		 * btPPPA
		 */
		btPPPA.setName("btPPPA");
		btPPPA.setText("PA");
		btPPPA.addActionListener(this);
		
		/*
		 * btPPAG
		 */
		btPPAG.setName("btPPAG");
		btPPAG.setText("AG");
		btPPAG.addActionListener(this);
		
		/*
		 * btPPGR
		 */
		btPPGR.setName("btPPGR");
		btPPGR.setText("GR");
		btPPGR.addActionListener(this);
		
		/*
		 * btPPRA
		 */
		btPPRA.setName("btPPRA");
		btPPRA.setText("RA");
		btPPRA.addActionListener(this);
		
		/*
		 * btPPAK
		 */
		btPPAK.setName("btPPAK");
		btPPAK.setText("AK");
		btPPAK.addActionListener(this);
		
		/*
		 * btPPKD
		 */
		btPPKD.setName("btPPKD");
		btPPKD.setText("KD");
		btPPKD.addActionListener(this);
		
		/*
		 * myHX
		 */
		myHX.setName("myHX");
		myHX.setText("Intercambiadores");
		myHX.add(btHXA);
		myHX.add(btHXK);
		myHX.add(btHXG);
		myHX.add(btLAMEED);
		myHX.add(btLAMEER);
		
		/*
		 * myPipe
		 */
		myPipe.setName("btPipe");
		myPipe.setText("Tubera");
		myPipe.add(btPPDP);
		myPipe.add(btPPPA);
		myPipe.add(btPPAG);
		myPipe.add(btPPGR);
		myPipe.add(btPPRA);
		myPipe.add(btPPAK);
		myPipe.add(btPPKD);
		
		/*
		 * mySet
		 */
		mySet.setName("mySet");
		mySet.setText("Ajustar");
		mySet.add(myHX);
		mySet.add(btPump);
		mySet.add(myPipe);
		mySet.add(btOA);
		mySet.add(btRA);
		mySet.add(btWKI);
		mySet.add(btSGI);
		mySet.add(btIN);
		
		/*
		 * myFile
		 */
		myFile.setName("myFile");
		myFile.setText("Archivo");
		myFile.add(btClose);
		
		/*
		 * myTools
		 */
		myTools.setName("myTools");
		myTools.setText("Herramientas");
		myTools.add(mySet);
		myTools.add(btAbout);
		
		/*
		 * myMenu
		 */
		myMenu.setName("myMenu");
		myMenu.add(myFile);
		myMenu.add(myTools);
		
		/* 
		 * lbNwKo
		 */
		lbNwKo.setName("lbNwKo");
		lbNwKo.setText("N_wKo");
		lbNwKo.setSize(dimLabel);
		lbNwKo.setLocation(270, 240);
		
		/* 
		 * lbNsGo
		 */
		lbNsGo.setName("lbNsGo");
		lbNsGo.setText("N_sGo");
		lbNsGo.setSize(dimLabel);;
		lbNsGo.setLocation(440, 10);
		
		/* 
		 * lbTtDo
		 */
		lbNtDo.setName("lbNtDo");
		lbNtDo.setText("N_tDo");
		lbNtDo.setSize(dimLabel);
		lbNtDo.setLocation(55,35);
		
		/*
		 * lbNxRo
		 */
		lbNxRo.setName("lbNxRo");
		lbNxRo.setText("N_xRo");
		lbNxRo.setSize(dimLabel);
		lbNxRo.setLocation(580, 35);
		
		/*
		 * lbNhDo
		 */
		lbNhDo.setName("lbNhDo");
		lbNhDo.setText("N_hDo");
		lbNhDo.setSize(dimLabel);
		lbNhDo.setLocation(200,80);
		
		/*
		 * lbNcRo
		 */
		lbNcRo.setName("lbNcRo");
		lbNcRo.setText("N_cRo");
		lbNcRo.setSize(dimLabel);
		lbNcRo.setLocation(440, 170);
		
		/*
		 * rbTem
		 */
		rbTem.setName("rbTem");
		rbTem.setText("Temperatura");
		rbTem.setSize(dimRButton);
		rbTem.setSelected(true);
		rbTem.setLocation(20, 280);
		rbTem.addItemListener(this);
		rbTem.setEnabled(false);
		
		/*
		 * rbHum
		 */
		rbHum.setName("rbHum");
		rbHum.setText("Humedad");
		rbHum.setSize(dimRButton);
		rbHum.setLocation(150, 280);
		rbHum.addItemListener(this);
		rbHum.setEnabled(false);
		
		/*
		 * rbPre
		 */
		rbPre.setName("rbPre");
		rbPre.setText("Presin");
		rbPre.setLocation(280, 280);
		rbPre.setSize(dimRButton);
		rbPre.addItemListener(this);
		rbPre.setEnabled(false);
		/*
		 * rbCon
		 */
		rbCon.setName("rbCon");
		rbCon.setText("Concentracin");
		rbCon.setLocation(410, 280);
		rbCon.setSize(dimRButton);
		rbCon.addItemListener(this);
		rbCon.setEnabled(false);
		
		/*
		 * rbMF
		 */
		rbMF.setName("rbMF");
		rbMF.setText("Flujo msico");
		rbMF.setLocation(540, 280);
		rbMF.setSize(dimRButton);
		rbMF.addItemListener(this);
		rbMF.setEnabled(false);
		
		/*
		 * bgUnit
		 */
		bgUnit.add(rbTem);
		bgUnit.add(rbHum);
		bgUnit.add(rbPre);
		bgUnit.add(rbCon);
		bgUnit.add(rbMF);
		
		/*
		 * btSim
		 */
		btSim.setName("btSim");
		btSim.setText("Simular");
		btSim.setSize(dimButton);
		btSim.setLocation(450, 340);
		btSim.addActionListener(this);
		
		/*
		 * btReport
		 */
		btReport.setName("btReport");
		btReport.setText("Reportar");
		btReport.setSize(dimButton);
		btReport.setLocation(570, 340);
		btReport.addActionListener(this);
		
		/*
		 * PictureBox1
		 */
		PictureBox1.setLayout(null);
		PictureBox1.setSize(680,270);
		PictureBox1.setLocation(5, 5);
		PictureBox1.setBackground(Color.WHITE);
		PictureBox1.add(lbNwKo);
		PictureBox1.add(lbNsGo);
		PictureBox1.add(lbNtDo);
		PictureBox1.add(lbNxRo);
		PictureBox1.add(lbNhDo);
		PictureBox1.add(lbNcRo);
		
		/*
		 * Container
		 */
		Container.setName("Container");
		Container.setLayout(null);
		Container.add(rbTem);
		Container.add(rbHum);
		Container.add(rbPre);
		Container.add(rbCon);
		Container.add(rbMF);
		Container.add(btSim);
		Container.add(btReport);
		Container.add(PictureBox1);
		
		/*
		 * GSim
		 */
		this.setSize(695, 430);
		this.setLocationRelativeTo(null);
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.setResizable(false);
		this.setLayout(new BorderLayout());
		this.add(myMenu, BorderLayout.NORTH);
		this.add(Container,BorderLayout.CENTER);
		
	}
	
	private void InitImage(){
		try{
			URL myURL = GSim.class.getResource("GraphSistema.png");
			myImage1 = ImageIO.read(myURL);
		} catch (IOException ex){
			
		}
	}
	
	protected double getRH(Node node){
		try{
		node.verifyFluid();
		} catch(OutOfRangeException ex){
			// Not catchable
		}
		Air a = (Air) node.getFluid();
		return a.getRH();
	}
	
    private class PrintResults extends SwingWorker<Void, Void> {
        @Override
        public Void doInBackground() {
        	setProgress(0);
        	PrintWriter pw = null;
        	try{
    			double i, j, v;
    			pw = new PrintWriter(new FileWriter(filepath));
    			System.out.println("#m_tDi: " + String.format(Locale.US, "%.2f", mySim.getN_tDi().getMFlow() * 3600.0) + " kg/h");
    			System.out.print("#T_xRi: " + String.format(Locale.US, "%.1f", mySim.getN_xRi().getTem()) + "C; ");
    			System.out.print("RH_xRi: " + String.format(Locale.US, "%.2f", getRH(mySim.getN_xRi()) * 100.0) + "%; ");
    			System.out.println("m_x: " + String.format(Locale.US, "%.2f", mySim.R.getDI().getMFlow() * 3600.0) + " kg/h");
    			System.out.print("#T_wKi: " + String.format(Locale.US, "%.1f", mySim.getN_wKi().getTem()) + "C; ");
    			System.out.println("m_w: " + String.format(Locale.US, "%.2f", mySim.getN_wKi().getMFlow() * 3600.0) + " kg/h");
    			System.out.print("#T_sGi: " + String.format(Locale.US, "%.1f", mySim.getN_sGi().getTem()) + "C; ");
    			System.out.println("m_s: " + String.format(Locale.US, "%.2f", mySim.getN_sGi().getMFlow() * 3600.0) + " kg/h");
    			System.out.println("#T_tDi\tW_tDi\tHR_tDi\teS_D\teL_D\tT_tDo\tW_tDo\tRH_tDo\tT_cDi\tX_cDi\t"
    					+ "T_hDo\tX_hDo\tT_hRi\tX_hRi\teS_R\teL_R\tT_cRo\tX_cRo\tT_xRo\tW_xRo\t"
    					+ "RH_xRo\tT_wKo\tT_sGo\tW_p");
    			pw.println("#m_tDi: " + String.format(Locale.US, "%.2f", mySim.getN_tDi().getMFlow() * 3600.0) + " kg/h");
    			pw.print("#T_xRi: " + String.format(Locale.US, "%.1f", mySim.getN_xRi().getTem()) + "C; ");
    			pw.print("RH_xRi: " + String.format(Locale.US, "%.2f", getRH(mySim.getN_xRi()) * 100.0) + "%; ");
    			pw.println("m_x: " + String.format(Locale.US, "%.2f", mySim.R.getDI().getMFlow() * 3600.0) + " kg/h");
    			pw.print("#T_wKi: " + String.format(Locale.US, "%.1f", mySim.getN_wKi().getTem()) + "C; ");
    			pw.println("m_w: " + String.format(Locale.US, "%.2f", mySim.getN_wKi().getMFlow() * 3600.0) + " kg/h");
    			pw.print("#T_sGi: " + String.format(Locale.US, "%.1f", mySim.getN_sGi().getTem()) + "C; ");
    			pw.println("m_s: " + String.format(Locale.US, "%.2f", mySim.getN_sGi().getMFlow() * 3600.0) + " kg/h");
    			pw.println("#T_tDi\tW_tDi\tHR_tDi\teS_D\teL_D\tT_tDo\tW_tDo\tRH_tDo\tT_cDi\tX_cDi\t"
    					+ "T_hDo\tX_hDo\tT_hRi\tX_hRi\teS_R\teL_R\tT_cRo\tX_cRo\tT_xRo\tW_xRo\t"
    					+ "RH_xRo\tT_wKo\tT_sGo\tW_p");
    			i = range[0][0];
    			Air air = new Air();
    			air.setPressure(mySim.getN_tDi().getPressure());
    			while(i <= range[0][1]){
    				v = (i - range[0][0]) / (range[0][1] - range[0][0]) * 100.0;
    				setProgress(Math.min((int) v, 100));
    				mySim.getN_tDi().setTem(i);
    				air.setTem(i);
        			j = range[1][0];
    				while(j <= range[1][1]){
    					air.setRH(j);
    					mySim.getN_tDi().setXCon(Air.getXConForW(air.getHum()));
    					mySim.getN_cKi().setTem(15.0);
    					mySim.getN_cKi().setXCon(0.3);
    					mySim.getN_cKi().setMFlow(3000. / 3600.);
    					mySim.run();
    					System.out.println(String.format(Locale.US, "%.1f", mySim.getN_tDi().getTem()) + "\t" 
    							+ String.format(Locale.US, "%.1f", mySim.getN_tDi().getHum() * 1000.0) + "\t"
    							+ String.format(Locale.US, "%.1f", getRH(mySim.getN_tDi()) * 100.0) + "\t"
    							+ String.format(Locale.US, "%.2f", mySim.D.getEffS()) + "\t"
    							+ String.format(Locale.US, "%.2f", mySim.D.getEffL()) + "\t" 
    							+ String.format(Locale.US, "%.1f", mySim.getN_tDo().getTem()) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_tDo().getHum() * 1000.0) + "\t"
    							+ String.format(Locale.US, "%.1f", getRH(mySim.getN_tDo()) * 100.0) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_cDi().getTem()) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_cDi().getXCon() * 1000.0) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_hDo().getTem()) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_hDo().getXCon() * 1000.0) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_hRi().getTem()) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_hRi().getXCon() * 1000.0) + "\t"
    							+ String.format(Locale.US, "%.2f", mySim.R.getEffS()) + "\t"
    							+ String.format(Locale.US, "%.2f", mySim.R.getEffL()) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_cRo().getTem()) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_cRo().getXCon() * 1000.0) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_xRo().getTem()) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_xRo().getXCon() * 1000.0) + "\t"
    							+ String.format(Locale.US, "%.1f", getRH(mySim.getN_xRo()) * 100.0) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_wKo().getTem()) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_sGo().getTem()) + "\t"
    							+ String.format(Locale.US, "%.2f", mySim.P.getPMPPower())
    							);	
    					pw.println(String.format(Locale.US, "%.1f", mySim.getN_tDi().getTem()) + "\t" 
    							+ String.format(Locale.US, "%.1f", mySim.getN_tDi().getHum() * 1000.0) + "\t"
    							+ String.format(Locale.US, "%.1f", getRH(mySim.getN_tDi()) * 100.0) + "\t"
    							+ String.format(Locale.US, "%.2f", mySim.D.getEffS()) + "\t"
    							+ String.format(Locale.US, "%.2f", mySim.D.getEffL()) + "\t" 
    							+ String.format(Locale.US, "%.1f", mySim.getN_tDo().getTem()) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_tDo().getHum() * 1000.0) + "\t"
    							+ String.format(Locale.US, "%.1f", getRH(mySim.getN_tDo()) * 100.0) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_cDi().getTem()) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_cDi().getXCon() * 1000.0) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_hDo().getTem()) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_hDo().getXCon() * 1000.0) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_hRi().getTem()) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_hRi().getXCon() * 1000.0) + "\t"
    							+ String.format(Locale.US, "%.2f", mySim.R.getEffS()) + "\t"
    							+ String.format(Locale.US, "%.2f", mySim.R.getEffL()) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_cRo().getTem()) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_cRo().getXCon() * 1000.0) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_xRo().getTem()) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_xRo().getXCon() * 1000.0) + "\t"
    							+ String.format(Locale.US, "%.1f", getRH(mySim.getN_xRo()) * 100.0) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_wKo().getTem()) + "\t"
    							+ String.format(Locale.US, "%.1f", mySim.getN_sGo().getTem()) + "\t"
    							+ String.format(Locale.US, "%.2f", mySim.P.getPMPPower())
    							);		
    					j += 0.01;
    				}
    				pw.println();
    				i += 1.0;
    			}
    			repRes = true;
    		} catch (IOException ex){
    			repRes = false;
    			System.out.println(ex.getMessage());
    			return null;
    		} catch (OutOfRangeException ex){
    			System.out.println(ex.getMessage());
    			System.out.println("At: GSim.PrintResults()");
    			repRes = false;
    			return null;
    		} finally {
    			if (pw != null){
    				pw.close();
    			}
    		}
        	return null;
        }
        
        @Override
        public void done() {
            progressMonitor.close();
        }
    }
	
	@Override
	public void actionPerformed(ActionEvent ev) {
		if(ev.getSource() == btSim){
			rbTem.setEnabled(true);
			rbHum.setEnabled(true);
			rbPre.setEnabled(true);
			rbCon.setEnabled(true);
			rbMF.setEnabled(true);
			mySim.run();
			setTems();
			rbTem.setSelected(true);
		} else if(ev.getSource() == btReport){
			if(GReport.showDialog(this)){
				progressMonitor = new GProgressMonitor(this);
				progressMonitor.setProgress(0);
				PrintResults pr = new PrintResults();
				pr.addPropertyChangeListener(this);
				pr.execute();
			} 
		} else if(ev.getSource() == btHXA){
			double[] data = new double[5];
			if (mySim.A.isFixed()){
				data[0] = 0.0;
				data[1] = mySim.A.getEffS();
			} else {
				data[0] = 1.0;
				data[1] = mySim.A.getUA();
			}
			data[2] = mySim.A.getSPL();
			data[3] = mySim.A.getDPL();
			data[4] = 0.0;
			
			data = GHX.getData(this, "HX A", data, GHX.Modality.HX);
			
			if (data[0] > 0.9){
				mySim.A.setUA(data[1]);
			} else {
				mySim.A.setEffS(data[1]);
			}
			mySim.A.setSPL(data[2]);
			mySim.A.setDPL(data[3]);
		} else if (ev.getSource() == btHXG){
			double[] data = new double[5];
			if (mySim.G.isFixed()){
				data[0] = 0.0;
				data[1] = mySim.G.getEffS();
			} else {
				data[0] = 1.0;
				data[1] = mySim.G.getUA();
			}
			data[2] = mySim.G.getSPL();
			data[3] = mySim.G.getDPL();
			data[4] = 0.0;
			
			data = GHX.getData(this, "HX G", data, GHX.Modality.HX);
			
			if (data[0] > 0.9){
				mySim.G.setUA(data[1]);
			} else {
				mySim.G.setEffS(data[1]);
			}
			mySim.G.setSPL(data[2]);
			mySim.G.setDPL(data[3]);
		} else if(ev.getSource() == btHXK){
			double[] data = new double[5];
			if (mySim.K.isFixed()){
				data[0] = 0.0;
				data[1] = mySim.K.getEffS();
			} else {
				data[0] = 1.0;
				data[1] = mySim.K.getUA();
			}
			data[2] = mySim.K.getSPL();
			data[3] = mySim.K.getDPL();
			data[4] = 0.0;
			
			data = GHX.getData(this, "HX K", data, GHX.Modality.HX);
			
			if (data[0] > 0.9){
				mySim.K.setUA(data[1]);
			} else {
				mySim.K.setEffS(data[1]);
			}
			mySim.K.setSPL(data[2]);
			mySim.K.setDPL(data[3]);
		} else if (ev.getSource() == btLAMEED){
			double[] data = new double[5];
			if (mySim.D.isFixed()){
				data[0] = 0.0;
				data[1] = mySim.D.getEffS();
				data[4] = mySim.D.getEffL();
			} else {
				data[0] = 1.0;
				data[1] = mySim.D.getUA();
				data[4] = mySim.D.getUA_m() * 1000.0;
			}
			data[2] = mySim.D.getSPL();
			data[3] = mySim.D.getDPL();
			
			data = GHX.getData(this, "LAMEE D", data, GHX.Modality.LAMEE);
			
			if (data[0] > 0.9){
				mySim.D.setUA(data[1]);
				mySim.D.setUA_m(data[4] / 1000.0);
			} else {
				mySim.D.setEffS(data[1]);
				mySim.D.setEffL(data[4]);
			}
			mySim.D.setSPL(data[2]);
			mySim.D.setDPL(data[3]);
		} else if (ev.getSource() == btLAMEER){
			double[] data = new double[5];
			if (mySim.R.isFixed()){
				data[0] = 0.0;
				data[1] = mySim.R.getEffS();
				data[4] = mySim.R.getEffL();
			} else {
				data[0] = 1.0;
				data[1] = mySim.R.getUA();
				data[4] = mySim.R.getUA_m() * 1000.0;
			}
			data[2] = mySim.R.getSPL();
			data[3] = mySim.R.getDPL();
			
			data = GHX.getData(this, "LAMEE R", data, GHX.Modality.LAMEE);
			
			if (data[0] > 0.9){
				mySim.R.setUA(data[1]);
				mySim.R.setUA_m(data[4] / 1000.0);
			} else {
				mySim.R.setEffS(data[1]);
				mySim.R.setEffL(data[4]);
			}
			mySim.R.setSPL(data[2]);
			mySim.R.setDPL(data[3]);
		} else if(ev.getSource() == btPump){
			mySim.P = GPump.getData(this, "Bomba", mySim.P);
		} else if(ev.getSource() == btPPDP){
			mySim.DP = GPipe.showDialog(this, "Tubera DP", mySim.DP);
		} else if(ev.getSource() == btPPPA){
			mySim.PA = GPipe.showDialog(this, "Tubera PA", mySim.PA);
		} else if(ev.getSource() == btPPAG){
			mySim.AG = GPipe.showDialog(this, "Tubera AG", mySim.AG);
		} else if(ev.getSource() == btPPGR){
			mySim.GR = GPipe.showDialog(this, "Tubera GR", mySim.GR);
		} else if(ev.getSource() == btPPRA){
			mySim.RA = GPipe.showDialog(this, "Tubera RA", mySim.RA);
		} else if(ev.getSource() == btPPAK){
			mySim.AK = GPipe.showDialog(this, "Tubera AK", mySim.AK);
		} else if(ev.getSource() == btPPKD){
			mySim.KD = GPipe.showDialog(this, "Tubera KD", mySim.KD);
		} else if(ev.getSource() == btOA){
			try{
				mySim.setN_tDi(GNode.getData(this, "Aire exterior", mySim.getN_tDi(), GNode.Modality.KEEP_FLUID));
			} catch(OutOfRangeException ex){
				JOptionPane.showMessageDialog(this, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
			}
		} else if(ev.getSource() == btRA){
			try{
				mySim.setN_xRi(GNode.getData(this, "Aire retorno", mySim.getN_xRi(), GNode.Modality.KEEP_PRESSURE));
			} catch(OutOfRangeException ex){
				JOptionPane.showMessageDialog(this, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
			}
		} else if(ev.getSource() == btWKI){
			try{
				mySim.setN_wKi(GNode.getData(this, "Agua preenfriamiento", mySim.getN_wKi(), GNode.Modality.KEEP_XCON));
			} catch(OutOfRangeException ex){
				JOptionPane.showMessageDialog(this, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
			}
		} else if(ev.getSource() == btSGI){
			try{
				mySim.setN_sGi(GNode.getData(this, "Agua precalentamiento", mySim.getN_sGi(), GNode.Modality.KEEP_XCON));
			} catch(OutOfRangeException ex){
				JOptionPane.showMessageDialog(this, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
			}
		} else if(ev.getSource() == btIN){
			try{
				mySim.setN_cKi(GNode.getData(this, "Lquido desecante", mySim.getN_cKi(), GNode.Modality.KEEP_PRESSURE));
			} catch(OutOfRangeException ex){
				JOptionPane.showMessageDialog(this, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
			}
		} else if(ev.getSource() == btAbout){
			GAbout ga = new GAbout(this);
			ga.setVisible(true);
			ga.dispose();
		} else if(ev.getSource() == btClose){
			this.dispose();
		}
	}
	
	@Override
	public void itemStateChanged(ItemEvent ev) {
		if(ev.getSource() == rbTem){
			lbNwKo.setVisible(true);
			lbNsGo.setVisible(true);
			lbNhDo.setVisible(true);
			lbNcRo.setVisible(true);
			setTems();
		} else if(ev.getSource() == rbHum){
			lbNwKo.setVisible(false);
			lbNsGo.setVisible(false);
			lbNhDo.setVisible(false);
			lbNcRo.setVisible(false);
			setHums();
		} else if(ev.getSource() == rbPre){
			lbNwKo.setVisible(true);
			lbNsGo.setVisible(true);
			lbNhDo.setVisible(true);
			lbNcRo.setVisible(true);
			setPres();
		} else if(ev.getSource() == rbCon){
			lbNwKo.setVisible(false);
			lbNsGo.setVisible(false);
			lbNhDo.setVisible(true);
			lbNcRo.setVisible(true);
			setXCons();
		} else { // ev.getSource() == rbMF
			setMFs();
			lbNwKo.setVisible(true);
			lbNsGo.setVisible(true);
			lbNhDo.setVisible(true);
			lbNcRo.setVisible(true);
		}
		
	}
	
	public void setTems(){
		lbNtDo.setText(String.format("%.2f", mySim.getN_tDo().getTem()) + "C");
		lbNxRo.setText(String.format("%.2f", mySim.getN_xRo().getTem()) + "C");
		lbNwKo.setText(String.format("%.2f", mySim.getN_cKo().getTem()) + "C");
		lbNsGo.setText(String.format("%.2f", mySim.getN_sGo().getTem()) + "C");
		lbNhDo.setText(String.format("%.2f", mySim.getN_hDo().getTem()) + "C");
		lbNcRo.setText(String.format("%.2f", mySim.getN_cRo().getTem()) + "C");
	}
	
	public void setHums(){
		lbNtDo.setText(String.format("%.2f", getRH(mySim.getN_tDo()) * 100.0) + "%");
		lbNxRo.setText(String.format("%.2f", getRH(mySim.getN_xRo()) * 100.0) + "%");
	}
	
	public void setPres(){
		lbNtDo.setText(String.format("%.2f", mySim.getN_tDo().getPressure()) + " kPa");
		lbNxRo.setText(String.format("%.2f", mySim.getN_xRo().getPressure()) + " kPa");
		lbNhDo.setText(String.format("%.2f", mySim.getN_hDo().getPressure()) + " kPa");
		lbNcRo.setText(String.format("%.2f", mySim.getN_cRo().getPressure()) + " kPa");
		lbNwKo.setText(String.format("%.2f", mySim.getN_wKo().getPressure()) + " kPa");
		lbNsGo.setText(String.format("%.2f", mySim.getN_sGo().getPressure()) + " kPa");
	}
	
	public void setXCons(){
		lbNtDo.setText(String.format("%.2f", mySim.getN_tDo().getXCon() * 1000.0) + " g/kg");
		lbNxRo.setText(String.format("%.2f", mySim.getN_xRo().getXCon() * 1000.0) + " g/kg");
		lbNhDo.setText(String.format("%.2f", mySim.getN_hDo().getXCon() * 1000.0) + " g/kg");
		lbNcRo.setText(String.format("%.2f", mySim.getN_cRo().getXCon() * 1000.0) + " g/kg");
		lbNwKo.setText(String.format("%.2f", mySim.getN_wKo().getXCon() * 1000.0) + " g/kg");
		lbNsGo.setText(String.format("%.2f", mySim.getN_sGo().getXCon() * 1000.0) + " g/kg");
	}
	
	public void setMFs(){
		lbNtDo.setText(String.format("%.2f", mySim.getN_tDo().getMFlow() * 3600.0) + " kg/h");
		lbNxRo.setText(String.format("%.2f", mySim.getN_xRo().getMFlow() * 3600.0) + " kg/h");
		lbNhDo.setText(String.format("%.2f", mySim.getN_hDo().getMFlow() * 3600.0) + " kg/h");
		lbNcRo.setText(String.format("%.2f", mySim.getN_cRo().getMFlow() * 3600.0) + " kg/h");
		lbNwKo.setText(String.format("%.2f", mySim.getN_wKo().getMFlow() * 3600.0) + " kg/h");
		lbNsGo.setText(String.format("%.2f", mySim.getN_sGo().getMFlow() * 3600.0) + " kg/h");
	}
	
	@Override
	public void propertyChange(PropertyChangeEvent evt) {
		if("progress" == evt.getPropertyName()){
			int progress = (Integer) evt.getNewValue();
			progressMonitor.setProgress(progress);
			if(progress  > 100) {
				if (repRes){
					JOptionPane.showMessageDialog(this, "Reporte exitoso");
				} else {
					JOptionPane.showMessageDialog(this, "Los datos no son confiables");
				}
			}
		}
	}
	
	public static void main(String[] args){
		GSim mysim = new GSim();
		mysim.setVisible(true);
	}

}
