package SIM;

public class Sim1 {
	public static double getDeltaH(double thi, double Wi, double tho, double Wo){
		double h_o, h_i;
		h_o = 1.007 * tho + Wo * (2501 + 1.86 * tho);
		h_i = 1.007 * thi + Wi * (2501 + 1.86 * thi);
		return  h_o - h_i;
	}
	
	public static void main(String args[]){
		
		// Input parameters
		double T_tDi = 20.0; // C
		double T_xRi = 25.0; // C
		double T_wKi = 15.0; // C
		double T_sGi = 70.0; // C
		double W_tDi = 0.012; // kg/kg
		double W_xRi = 0.012; // kg/kg
		double X_cDi = 0.01; // kg/kg
		double m_t = 0.5; // kg/s
		double m_x = 0.5; // kg/s
		double m_dl = 1.0; // kg/s
		double m_w = 1.0; // kg/s
		double m_s = 1.0; // kg/s
		double c_w = 4.2; // kJ/kg-K
		double c_dl = 2.1; // kJ/kg-K
		double ep_A = 0.8;
		double ep_K = 0.8;
		double ep_G = 0.8;
		double ep_Dsen = 0.8;
		double ep_Dlat = 0.8;
		double ep_Rsen = 0.8;
		double ep_Rlat = 0.8;
		double Q_AD = 0.0; // C
		double Q_AG = 0.0; // C
		double Q_GR = 0.0; // C
		double Q_AR = 0.0; // C
	    double Q_AK = 0.0; // C
	    double Q_DK = 0.0; // C
	    double C_w, C_s, C_t, C_x, C_dl;
	    double C_minK, C_minG, C_minD, C_minR;
	    double M_minD, M_minR;
	    double T_cDi;
		double T_hDo; // C
		double T_hRi; // C

		double T_cAi, T_cAo, T_hAo, T_hAi, T_hGi, T_xRo, T_cRo; // C
		double T_hGo, T_cKi, T_cKo, T_tDo; // C
		double X_hDo, X_hRi, X_cRo;
		double W_xRo, W_tDo; // kg/kg
		C_w = c_w * m_w;
		C_s = c_w * m_s;
		C_t = 1.04 * m_t;
		C_x = 1.04 * m_x;
		C_dl = c_dl * m_dl;
		C_minK = Math.min(C_w, C_dl);
		C_minG = Math.min(C_s, C_dl);
		C_minD = Math.min(C_t, C_dl);
		C_minR = Math.min(C_x, C_dl);
		M_minD = Math.min(m_t, m_dl);
		M_minR = Math.min(m_x, m_dl);
		int k = 0;
		double delta1 = 100;
		double delta2 = 100;
		double ref1, ref2;

		/* Primero asumimos que las temperaturas de entrada y salida en K
		 * son iguales a la temperatura de entrada del agua potable
		 */
		ref1 = T_wKi; ref2 = X_cDi;
		T_cDi = T_cKo = T_cAi = T_cKi = T_tDo = T_cRo = T_xRo = ref1;
		X_cRo = X_hDo = W_tDo = X_hRi = W_xRo = X_cDi;
		// Comienza el ciclo Gauss-Seidel
		System.out.println("n\tT_tDo\tW_tDo\tT_cDi\tX_cDi\tT_hDo\tX_hDo\tT_hRi" 
				+ "\tX_hRi\tT_cRo\tX_cRo\tT_xRo\tW_xRo\tdelta");
		while (k < 100 && (delta1 > 0.001 || delta2 > 1E-5)){
			// Tubera de K a D
			T_cDi = T_cKo + Q_DK / m_dl / c_dl;
			X_cDi = X_cRo;
			// Salida del aire tratado por el deshumidificador
			T_tDo = T_tDi - ep_Dsen * C_minD / C_t *(T_tDi - T_cDi);
			W_tDo = W_tDi - ep_Dlat * M_minD / m_t *(W_tDi - X_cDi);
			// Salida del lquido desecante del deshumidificador
			T_hDo = T_cDi + getDeltaH(T_tDi, W_tDi, T_tDo, W_tDo) / m_dl / c_dl;
			X_hDo = X_cDi + m_t / m_dl * (W_tDi - W_tDo);
			// Tubera de D a A
			T_hAi = T_hDo + Q_AD / m_dl / c_dl;
			// Intercambiador A en lnea h
			T_hAo = T_hAi - ep_A * (T_hAi - T_cAi);
			// Tubera de A a G
			T_hGi = T_hAo + Q_AG / m_dl / c_dl;
			// Intercambiador G
			//T_sGo = T_sGi - ep_G * C_minG / C_s * (T_sGi - T_hGi);
			T_hGo = T_hGi + ep_G * C_minG / C_dl * (T_sGi - T_hGi);
			// Tubera de G a R
			T_hRi = T_hGo + Q_GR / m_dl / c_dl;
			X_hRi = X_hDo;
			// Salida del aire tratado por el regenerador
			T_xRo = T_xRi - ep_Rsen * C_minR / C_x * (T_xRi - T_hRi);
			W_xRo = W_xRi - ep_Rlat * M_minR / m_x * (W_xRi - X_hRi);
			// Salida del lquido desecante del regenerador	
			T_cRo = T_hRi + getDeltaH(T_xRi, W_xRi, T_xRo, W_xRo) / m_dl / c_dl;
			X_cRo = X_hRi + m_x / m_dl * (W_xRi - W_xRo);
			// Tubera de R a A
			T_cAi = T_cRo + Q_AR / m_dl / c_dl;
			// Intercambiador A por la lnea c
			T_cAo = T_cAi - ep_A * (T_cAi - T_hAi);
			// Tubera de A a K
			T_cKi = T_cAo + Q_AK / m_dl / c_dl;
			// Intercambiador K
			//T_wKo = T_wKi + ep_K * C_minK / C_w * (T_cKi - T_wKi);
			T_cKo = T_cKi - ep_K * C_minK / C_dl * (T_cKi - T_wKi);
			// Termina el ciclo y se compara la referencia
			System.out.println(String.valueOf(k) + "\t" + String.format("%.2f", T_tDo)
				+ "\t" + String.format("%.2f", W_tDo * 1000) + "\t" + String.format("%.2f", T_cDi)
				+ "\t" + String.format("%.2f", X_cDi * 1000) + "\t" + String.format("%.2f", T_hDo) 
				+ "\t" + String.format("%.2f", X_hDo * 1000) + "\t" + String.format("%.2f", T_hRi)
				+ "\t" + String.format("%.2f", X_hRi * 1000) + "\t" + String.format("%.2f", T_cRo)
				+ "\t" + String.format("%.2f", X_cRo * 1000) + "\t" + String.format("%.2f", T_xRo)
				+ "\t" + String.format("%.2f", W_xRo * 1000) + "\t" + String.format("%.5f", delta2));
			k++;
			delta1 = Math.abs(T_cKo - ref1);
			delta2 = Math.abs(X_cDi - ref2);
			ref1 = T_cKo; ref2 = X_cDi;
		}
	}
}

